******************************************************************************
      subroutine cdEms( chLabel , length , emiss , lgOK )
      implicit none
*obtain the local emissivity for a line, for the last computed zone
      logical lgOK
      character*4 chLabel
      integer length
      real emiss
*
      include "nlines.par"
      include "sum.com"
      include "sum2.com"
      include "sumlab.com"
      include "fourpi.com"
      include "nsumtt.com"
*
*     local variables
      character*4 chCaps , chFind
      integer j
*
*     routine returns the emissivity in the desired line
*     only used internally by the code, to do punch lines structure
*
*     change chLabel to all caps
      call cap4( chLabel , chFind )
      do j=1,nsumtt
*       change chLabel to all caps to be like input chAmLab
        call cap4( chALab(j) , chCaps )
*       check wavelength and chLabel for a match
        if(lin(j).eq.length .and.chCaps.EQ.chFind) then
*         match, so set emiss to emissivity in line
          emiss = emslin(j)
          lgOK = .true.
          return
        endif
      end do
*
      lgOK = .false.
*
      end
