******************************************************************************
      subroutine comment
      implicit none
*analyze model, generating comments on its features
      include "ipLnArry.par"
      include "limelm.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nfst.par"
      include "ndfst.par"
      include "nlines.par"
      include "ncell.par"
      include "pi.par"
      include "solarm.par"
      include "itrdim.par"
      include "nfudgc.par"
      include "nzlim.par"
      include "ndust.par"
      include "nta.par"
      include "nwindline.par"
      include "nkrd.par"
      include "rydlam.par"
      include "TLineARR.com"
      include "Fe2Neg.com"
      include "LaMase.com"
      include "LyaExT.com"
      include "nzlmok.com"
      include "insanity.com"
      include "dCmHdT.com"
      include "deplon.com"
      include "ZoneCnt.com"
      include "caseb.com"
      include "EdError.com"
      include "HPhoto.com"
      include "plasnu.com"
      include "HionRad.com"
      include "Testit.com"
      include "opcneg.com"
      include "ednbad.com"
      include "ca2mly.com"
      include "broke.com"
      include "dr2sml.com"
      include "tseton.com"
      include "badstp.com"
      include "totlum.com"
      include "turhet.com"
      include "forcte.com"
      include "cmfrac.com"
      include "jmin.com"
      include "zonset.com"
      include "difher.com"
      include "nhe1.com"
      include "nhe2.com"
      include "prslim.com"
      include "dphoht.com"
      include "codish.com"
      include "h2dish.com"
      include "con0.com"
      include "negoi.com"
      include "abnslr.com"
      include "dstfac.com"
      include "comneg.com"
      include "static.com"
      include "negdrg.com"
      include "he.com"
      include "rfield.com"
      include "occmax.com"
      include "h2max.com"
      include "kapots.com"
      include "capots.com"
      include "nustbl.com"
      include "resmax.com"
      include "tgrmax.com"
      include "cldnEXP.com"
      include "phycon.com"
      include "hlmax.com"
      include "timesc.com"
      include "tenden.com"
      include "toiii.com"
      include "tautot.com"
      include "stimax.com"
      include "hextra.com"
      include "phlevl.com"
      include "ffheat.com"
      include "hmihet.com"
      include "nh.com"
      include "htau.com"
      include "tcool.com"
      include "heat.com"
      include "comptn.com"
      include "terode.com"
      include "number.com"
      include "tehigh.com"
      include "he1tau.com"
      include "he2tau.com"
      include "dalerr.com"
      include "radius.com"
      include "thlo.com"
      include "the1lo.com"
      include "the2lo.com"
      include "failz.com"
      include "nfail.com"
      include "IterCnt.com"
      include "he3tuEXP.com"
      include "taucon.com"
      include "sphere.com"
      include "drminu.com"
      include "iprdmx.com"
      include "prdcap.com"
      include "prad.com"
      include "cpres.com"
      include "fudgec.com"
      include "lyamas.com"
      include "phela.com"
      include "hemase.com"
      include "lastit.com"
      include "edgtcm.com"
      include "physok.com"
      include "occ1hi.com"
      include "comund.com"
      include "hipop2.com"
      include "bndsok.com"
      include "frcind.com"
      include "called.com"
      include "habing.com"
      include "dstlab.com"
      include "reason.com"
      include "warngs.com"
      include "itagan.com"
      include "cyclot.com"
      include "he3pht.com"
      include "tff.com"
      include "filfac.com"
      include "windok.com"
      include "wind.com"
      include "GeoPP.com"
      include "rgcom.com"
      include "IOqq.com"
      include "h2ozer.com"
      include "ColDnSav.com"
      include "sublimat.com"
      include "he12on.com"
      include "cspset.com"
      include "sum.com"
      include "struc.com"
      include "Max2Pht.com"
      include "heatlmax.com"
      include "ExtraMax.com"
      include "WindData.com"
      include "TAddLya.com"
      include "PrnErr.com"
      include "erredn.com"
      include "double.com"
      include "turb.com"
      include "CHMax.com"
      include "mgexc.com"
      include "o3exc.com"
      include "BetaVer.com"
      include "NoConverge.com"
      include "autoit.com"
      include "input.com"
      include "IonFracs.com"
      include "CharExc.com"
*
*     local variables
      logical lgHe1thk,lgHe2thk
      logical lgOK
      character chLine*132  , chLbl*10 , chLineLbl*10, chGetLbl*10
      logical lgMaser , lgThick , lgFFimp
      real rel , outtot , outin,outout, reclin,totlin,t4363 , SumNeg
      real small,tauneg,aj,comfrc,ts,rate,relhm,flur,HBeta,relfl,alpha
      real big,bigm,differ,fedest,collin,absint,c4363,ratio
      real totwid , error , freqn , BigJump , GetHeat
      integer nd , imas , nneg , nline,nw,nc,nn,ns,i,j,isav
*
*     enter all comments cautions warnings and surprises into a large
*     stack of statements
*     at end of this routine is master call to printing routines
*
      lgIterAgain = .false.
*
*     free statement numbers >=9
*
*     initialize the line saver
      call wcnint
*
      if( nBetaVer.gt.0 ) then
        write(chLine,'(''  !This is beta test version'',i4,
     1  '' and should not be used for publications.'')')nBetaVer
        call bangin( chLine )
      endif
*
*     say why calculation stopped
      if( lgBadStop ) then
*       this case stop probably was not intended
        write(chRgcln(1),'('' W-Calculation stopped because '',A21,
     1  '' Iteration'',i3,'' of'',i3)') chReason,iter,itermx+1
        write(chLine,'('' W-Calculation stopped because '',A21)')
     1  chReason
        call warnin( chLine )
        write(chLine,'('' W-This was not intended.'')')
        call warnin( chLine )
      else
        if( lgAutoIt .and. iter.ne.itermx+1 .and.iter.gt.2 ) then
          write(chRgcln(1),'(''   Calculation stopped because '',A21,
     1    '' Iteration'',i3,'' of'',i3,'', not converged due to '',a10)'
     2    )chReason,iter,itermx+1, chNotConverged
        else
          write(chRgcln(1),'(''   Calculation stopped because '',A21,
     1    '' Iteration'',i3,'' of'',i3)')
     2    chReason,iter,itermx+1
        endif
      endif
*
*     check whether stopped because default number of zones hit,
*     not intended??
      if( (.not.lgZoneSet) .and. lgZoneTrp ) then
        lgBadStop = .true.
        write(chLine,'('' W-Calculation stopped because default '',
     1  ''number of zones reached.  Was this intended???'')')
        call warnin( chLine )
        write(chLine,'('' W-Default limit can be increased while'',
     1  '' retaining this check with the SET NEND command.'')')
        call warnin( chLine )
      endif
*
*     check whether stopped because zones too thin - only happens when glob set
*     and depth + dr = depth
*     not intended
      if( lgDrMinUsed .or. lgdR2Small ) then
        lgBadStop = .true.
        write(chLine,'('' W-Calculation stopped zone thickness '',
     1  ''became too thin.   This was not intended.'')')
        call warnin( chLine )
        write(chLine,'('' W-The most likely reason was an '',
     1  ''uncontrolled oscillation.'')')
        call warnin( chLine )
        call ShowMe
      endif
      if( lgdR2Small ) then
        write(chLine,'('' W-This happened because the globule '',
     1  ''scale became very small relative to the depth.'')')
        call warnin( chLine )
        write(chLine,'('' W-This problem is described in Hazy.'')')
        call warnin( chLine )
      endif
*
*     did insanity occur?
      if( lgInsane ) then
        lgBadStop = .true.
        write(chLine,'('' W-Insanity occurred.'')')
        call warnin( chLine )
        call ShowMe
        call warnin( chLine )
      endif
*
*     possible that last zone does not have stored temp - if so
*     then make it up - this happens for some bad stops
      if( testr(nzone).eq.0. ) testr(nzone) = testr(nzone-1)
      if( ednstr(nzone).eq.0. ) ednstr(nzone) = ednstr(nzone-1)
*
*     give indication of geometry
      rel = depth/rinner
      if( rel.lt.0.1 ) then
        write(chRgcln(2),'(''   The geometry is plane-parallel.'')')
        lgGeoPP = .true.
      else if(rel.ge.0.1 .and. rel.lt.3. ) then
        lgGeoPP = .false.
        write(chRgcln(2),'(''   The geometry is a thick shell.'')')
      else
        lgGeoPP = .false.
        write(chRgcln(2),'(''   The geometry is spherical.'')')
      endif
*
*     levels of warnings: Warning   (possibly major problems)
*                         Caution   (not likely to invalidate the results)
*                         [nothing] interesting note
*                         [      !] surprise, but not disaster
*
      if( nfudge.gt.0 ) then
        write(chLine,'('' W-Fudge factors in place.  Why?'')')
        call warnin( chLine )
      endif
*
      if( lgBroke ) then
        write(chLine,'('' W-The code is broken.'')')
        call warnin( chLine )
      endif
*
*     incorrect electron density detected in radinc during the calculation
      if( lgEdenBad ) then
        if( nzEdenBad.eq.nzone ) then
          write(chLine,'('' C-The assumed electron density was'',
     1    '' incorrect for the last zone.'')')
          call caunin( chLine )
          write(chLine,'('' C-Did a temperature discontinuity occur??''
     1    )')
          call caunin( chLine )
        else
          write(chLine,'('' W-The assumed electron density was'',
     1    '' incorrect during the calculation.  This is bad.'')')
          call warnin( chLine )
          call ShowMe
          call warnin( chLine )
        endif
      endif
*
      if( lgBusted ) then
        write(chLine,'('' W-The code returned with BUSTED set.'',
     1  ''  Something REALLY went wrong!'')')
        call warnin( chLine )
      endif
*
      if( hden .gt. 1.1e13 ) then
        if( hden.gt.1e15 ) then
          write(chLine,'('' W-Density greater than 10**15'')')
          call warnin( chLine )
        else
          write(chLine,'('' C-Density greater than 10**13'')')
          call caunin( chLine )
        endif
      endif
*
*     HBeta is used later in the code to check on line intensites
      call cdLine( 'Pump' , 4861 , relfl , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find flur H-beta'')')
      call cdLine( 'totl' , 4861 , HBeta , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find totl H-beta'')')
      if( HBeta.gt.0. ) then
        flur = relfl / HBeta
        if( flur.gt.0.01 ) then
          write(chLine,'(''   Continuum fluorescent production of '',
     1    ''H-beta was significant.'')')
          call notein( chLine )
        endif
      endif
*
*     check if there were problems with initial wind velocity
      if( windv0 .gt. 0. .and.
     1 ( (.not.lgWindOK).or.windv.lt.1e6 )   ) then
        write(chLine,'('' C-Wind velocity below sonic point;'',
     1  '' solution is not valid.'')')
        call caunin( chLine )
      endif
*
*     check that we didn't overrun zone scale
      if( nzone.ge.nzlim ) then
        lgZonLimOK = .false.
        write(chLine,'('' C-Number of zones exceeded NZLIM - '',
     1  '' several structure quantities are not valid.'')')
        call caunin( chLine )
        write(chLine,'('' C-Number of zones exceeded NZLIM - '',
     1  '' The emission line spectrum is ok though.'')')
        call caunin( chLine )
      else
        lgZonLimOK = .true.
      endif
*
*     check whether energy is conserved
*     following is outward continuum
      call outsum( outtot, outin, outout )
*     reclin is the sum of all recombination line energy
      reclin = totlin( 'r' )
      if( reclin.eq.0. ) then
        write(chLine,'(''   totlin(r) returned zero'')')
        call notein( chLine )
      endif
*     collin is the sum of all coolants
      collin = totlin( 'c' )
      if( collin.eq.0. ) then
        write(chLine,'(''   totlin(c) returned zero'')')
        call notein( chLine )
      endif
*     
*     TOTLUM is total incident photon luminosity, evaluated in setup
*     POWER is incremented in LINES and is the total heating integrated
*     over the computed volume
*     COLLIN is evaluated here, is sum of all coolants
      if( (collin+reclin).gt.totlum .and. (.not.lgTSetOn) ) then
        if( cryden.eq.0.  .and.turhet.eq.0. .and. .not.lgCSetOn ) then
*
          write(chLine,'('' W-Radiated luminosity (cool+rec='',1P,E8.2
     1    ,''+'',E9.2,'') is greater than that in incident ''
     2    ,''radiation (TOTLUM='',E8.2,'').  Power='',e8.2)')
     3    collin , reclin,totlum , power
          call warnin( chLine )
*         write same thing directly to output (above will be sorted later)
          write(qq,'('' This calculation DID NOT CONSERVE ENERGY!'')')
*         print out the offenders
          call badprt(totlum)
*
          write(chLine,'('' W-Something is really wrong: the ratio of ''
     1    ,''radiated to incident luminosity  is '',1P,E9.2,''.'')')
     2    (collin+reclin) / totlum
          call warnin( chLine )
*
*         this can be caused by the force te command
          if( ForceTemp.gt.0. ) then
            write(qq,'('' This may have been caused by the FORCE '',
     1      ''TE command.'')')
            write(qq,'('' Remove it and run again.'')')
          else
            call ShowMe
          endif
          call warnin( chLine )
        endif
      endif
*
*     warn if cosmic rays and bmag field both present
      if( cryden*CycloCoolCoef.gt.0. ) then
        write(chLine,'('' W-Magnetic field and cosmic rays are both'',
     1  '' present.  This is not correctly treated.'')')
        call warnin( chLine )
      endif
*
*     comment if test code is in place
      if( lgTestIt ) then
        write(chLine,'(''  !Test code is in place.'')')
        call bangin( chLine )
      endif
*
*     lgComUndr set to .true. if compton cooling rate underflows to 0
      if( lgComUndr ) then
        write(chLine,'(''  !Compton cooling rate underflows'',
     1  '' to zero.  Is this important?'')')
        call bangin( chLine )
      endif
*
*     lgHionRad set to .true. if no hydrogen ionizing radiation
      if( lgHionRad ) then
        write(chLine,'(''  !There is no Hydrogen-ionizing'',
     1  '' radiation.  Was this intended?'')')
        call bangin( chLine )
      endif
*
*     check whether certain zones were thermally unstable
      if( nUnstable.gt.0 ) then
        write(chLine,'(''   Derivative of net cooling negative ''
     1  ,''and so possibly thermally unstable in'',I4,'' zones.'')')
     2  nUnstable
        call notein( chLine )
      endif
*
*     did derivative of heating minus cooling every change sign during search
      if( lgCmHOsc ) then
        write(chLine,'(''   Derivative of net cooling oscillated ''
     1  ,''during thermal solution.  Standard fixup taken.'')')
        call notein( chLine )
      endif
*
*     generate a bang if a large fraction of the zones were unstable
      if( nzone.gt.1 .and. float(nUnstable)/float(nzone) .gt.0.25 ) then
        write(chLine,'(''  !A large fraction of the zones were '',
     1  ''possibly thermally unstable,'',i4,'' out of'',i4)')
     2  nUnstable , nzone
        call bangin( chLine )
      endif
*
*     comment if negative coolants were ever significant
      if( CoolHeatMax.gt. 0.2 ) then
        write(chLine,'(''  !Negative cooling reached '',f6.1''% of'',
     1  '' the local heating, due to '',a4,i6)') CoolHeatMax*100.,
     2  chCoolHeatMax,ipCoolHeatMax
        call bangin( chLine )
      else if (CoolHeatMax.gt.0.05 ) then
        write(chLine,'(''   Negative cooling reached '',f6.1''% of'',
     1  '' the local heating, due to '',a4,i6)')CoolHeatMax*100.,
     2   chCoolHeatMax,ipCoolHeatMax
        call notein( chLine )
      endif
*
*     did Lya mase?
      if( xLaMase.lt.0. ) then
        if( xLaMase.lt.-0.01 ) then
          write(chLine,'(''  !H Lya mased!!  Smallest optical depth'',
     1    '' was'',1p,e10.2)') xLaMase
          call bangin( chLine )
        else
          write(chLine,'(''   H Lya mased.  Smallest optical depth'',
     1    '' was'',1p,e10.2)') xLaMase
          call notein( chLine )
        endif
      endif
*
      if( kapots.gt.0 ) then
        write(chLine,'(''   KAPOTS='',I4,'' OTSCap='',1P,
     1  e10.3)') kapots,OTSCap
        call notein( chLine )
      endif
*
      if( kap911.gt.0 ) then
        write(chLine,'(''   KAP911='',I4,'' OTSCap='',1P,
     1  e10.3)') kap911,OTSCap
        call notein( chLine )
      endif
*
*     check whether photo from up level of Mg2 2798 ever important
      if( xMg2Max.gt.0.1 ) then
        write(chLine,'(''  !Photoionization of upper level of Mg II '',
     1  ''2798 reached '' ,F5.1,''% of the total Mg+ photo rate.'')')
     2  xMg2Max*100.
        call bangin( chLine )
      else if( xMg2Max.gt.0.01 ) then
        write(chLine,'(''   Photoionization of upper level of Mg II '',
     1  ''2798 reached '' ,F5.1,''% of the total Mg+ photo rate.'')')
     2  xMg2Max*100.
        call notein( chLine )
      endif
*
*     check whether photo from up level of [OI] 6300 ever important
      if( poimax.gt.0.1 ) then
        write(chLine,'(''  !Photoionization of upper levels of [OI]'',
     1  '' reached '' ,F5.1,''% of the total O destruction rate.'')')
     2  poimax*100.
        call bangin( chLine )
      else if( poimax.gt.0.01 ) then
        write(chLine,'(''   Photoionization of upper levels of [OI]'',
     1  '' reached '' ,F5.1,''% of the total O destruction rate.'')')
     2  poimax*100.
        call notein( chLine )
      endif
*
*     check whether photo from up level of [OIII] 5007 ever important
      if( (poiii2Max+poiii3Max).gt.0.1 ) then
        write(chLine,'(''  !Photoionization of upper levels of [OIII]'',
     1  '' reached '' ,F5.1,''% of the total O++ photo rate.'')')
     2  (poiii2Max+poiii3Max)*100.
        call bangin( chLine )
      else if( (poiii2Max+poiii3Max).gt.0.01 ) then
        write(chLine,'(''   Photoionization of upper levels of [OIII]'',
     1  '' reached '' ,F5.1,''% of the total O++ photo rate.'')')
     2  (poiii2Max+poiii3Max)*100.
        call notein( chLine )
      endif
*
*     check whether resonance line ionization of H n=2 was important
      if( resmax.gt.0.01 ) then
        write(chLine,'(''   FeII-MgII photoionization of H N=2 '',
     1  ''reached'' ,F5.1,'' percent of the total rate out.'')')
     2  resmax*100.
        call notein( chLine )
      endif
*
*     check whether photoionization of He 2trip S was important
      if( he3pht.gt.0.01 ) then
        write(chLine,'(''   Photoionization of He 2TriS reached '',
     1  F5.1,''% of the total rate out,'',F5.1,
     2  ''% of that was Lya.'')') he3pht*100. , he3lya*100.
        call notein( chLine )
      endif
*
*     frequency array may not have been defined for all energies
      if(.not.lgMMok) then
         write(chLine,'('' C-Continuum not defined in extreme'',
     1'' infrared - Compton scat, grain heating, not treated.?'')')
         call caunin( chLine )
      endif
      if(.not.lgHPhtOK) then
        write(chLine,'('' C-Continuum not defined at photon'',
     1  '' energies which ionize excited states of H, important for '',
     2  ''H- and ff heating.'')')
        call caunin( chLine )
      endif
      if(.not.lgXRayOK) then
        write(chLine,'('' C-Continuum not defined at x-ray energies'',
     1  '' - Compton scattering and Auger ionization wrong?'')')
        call caunin( chLine )
      endif
      if(.not.lgGamrOK) then
        write(chLine,'('' C-Continuum not defined at gamma-ray ''
     1  ,''energies - pair production and Compton scattering OK?'')')
        call caunin( chLine )
      endif
      if( lgCon0 ) then
        write(chLine,'('' C-Continuum zero at some energies.'')')
        call caunin( chLine )
      endif
*
      if( lgOcc1Hi ) then
        write(chLine,'(''  !The continuum occupation number'',
     1  '' at 1 Ryd is greater than unity.'')')
        call bangin( chLine )
      endif
*
*     check whether non-col excit of 4363 was important
      call cdLine( 'TOTL',4363, t4363, absint, lgOK)
      if(.not.lgOK ) then
        write(qq,'('' COMMNT could not find total OIII 4363 with cdLine.
     1'')')
        stop
      endif
      call cdLine( 'Coll',4363, c4363, absint, lgOK)
      if(.not.lgOK ) then
        write(qq,'('' COMMNT could not find collis OIII 4363 with cdLine
     1.'')')
        stop
      endif
*     only print this comment is 4363 is significant and density low
      if( HBeta.gt.1e-35 ) then
        if(t4363/HBeta.gt.1e-4  .and.  hden.lt.1e7 ) then
          ratio = (t4363-c4363)/t4363
          if( ratio.gt.0.01 ) then
            write(chLine,'(''  !Non-collisional excitation of'',
     1      '' [OIII] 4363 reached '',F6.2,''% of the total.'')')
     2      ratio * 100.
            call bangin( chLine )
          else if( ratio.gt.0.001 ) then
            write(chLine,'(''   Non-collisional excitation of'',
     1      '' [OIII] 4363 reached '',F6.2,''% of the total.'')')
     2      ratio * 100.
            call notein( chLine )
          endif
        endif
      endif
*
*     check for plasma shielding
      if( lgPlasNu ) then
        write(chLine,'(''  !The plasma frequency of the last zone was''
     1  ,1P,E9.2,
     1  '' Ryd.  The incident continuum is set to 0 below this.'')')
     2  plsfrq
        call bangin( chLine )
      endif
*
      if( occmax.gt.0.1) then
        if( occmnu.gt.1e-4 ) then
          write(chLine,'(''  !The largest continuum '',
     1    ''occupation number was'',1P,E10.3,'' at'',E10.3,'' Ryd.'')')
     2    occmax , occmnu
          call bangin( chLine )
        else
*         not surprising if occ num bigger than 1 around 1e-5 Ryd,
*         since this is the case for 3K background
          write(chLine,'(''   The largest continuum '',
     1    ''occupation number was'',1P,E10.3,'' at'',E10.3,'' Ryd.'')')
     2    occmax , occmnu
          call notein( chLine )
        endif
      endif
*
      if( occmax.gt.1e4 .and. occ1nu.gt.0. ) then
*       occ1nu is energy (ryd) where continuum occ num falls below 1
        if( occ1nu.lt.0.0912 ) then
          write(chLine,'(''   The continuum occupation number fell ''
     1    ,''below 1 at '',1P,E10.3,'' microns.'')') 0.0912/occ1nu
          call notein( chLine )
        else if( occ1nu.lt.1. ) then
          write(chLine,'(''   The continuum occupation number fell ''
     1    ,'' below 1 at '',1P,E10.3,'' Angstroms.'')') 912./occ1nu
          call notein( chLine )
        else
          write(chLine,'(''   The continuum occupation number fell ''
     1    ,'' below 1 at '',1P,E10.3,'' Ryd.'')') occ1nu
          call notein( chLine )
        endif
      endif
*
      if( tbrmax.gt.1e3) then
         write(chLine,'(''  !The largest continuum brightness'',
     1   '' temperature was'',1P,E10.3,''K at'',E10.3,'' Ryd.'')')
     2   tbrmax , tbrmnu
         call bangin( chLine )
      endif
*
      if( tbrmax.gt.1e4 ) then
*       tbr4nu is energy (ryd) where continuum bright temp falls < 1e4
        if( tbr4nu.lt.0.0912 ) then
          write(chLine,'(''   The continuum brightness temperature '',
     1    ''fell below 10,000K at '',1P,E10.3,'' microns.'')')
     2    0.0912/tbr4nu
          call notein( chLine )
        else if( tbr4nu.lt.1. ) then
          write(chLine,'(''   The continuum brightness temperature '',
     1    ''fell below 10,000K at '',1P,E10.3,'' Angstroms.'')')
     2    912./tbr4nu
          call notein( chLine )
        else
          write(chLine,'(''   The continuum brightness temperature '',
     1    ''fell below 10,000K at '',1P,E10.3,'' Ryd.'')') tbr4nu
          call notein( chLine )
        endif
      endif
*
*     turbulence AND constant pressure do not make sense
      if( TurbVel.gt.0. .and. chCPres.eq.'CPRE' ) then
        write(chLine,'(''  !Both constant pressure and turbulence'',
     1  '' makes no physical sense???'')')
        call bangin( chLine )
      endif
*
*     filling factor AND constant pressure do not make sense
      if( FillFac.lt.1. .and. chCPres.eq.'CPRE' ) then
        write(chLine,'(''  !Both constant pressure and a filling '',
     1  ''factor makes no physical sense???'')')
        call bangin( chLine )
      endif
*
*     grains and solar abundances do not make sense
      if( lgDustOn.and.lgAbnSolar ) then
        write(chLine,'(''  !Grains are present, but the gas phase '',
     1  ''abundances were left at the solar default.  '',
     2  ''This is not physical.'')')
        call bangin( chLine )
      endif
*
*     check if depletion command set but no grains, another silly thing to do
      if( lgDepln .and. .not.lgDustOn ) then
        write(chLine,'(''  !Grains are not present, but the gas phase'',
     1  '' abundances were depleted.  This is not physical.'')')
        call bangin( chLine )
      endif
*
*     PAH physics is not correct
      if( lgDustOn1(9) .or. lgDustOn1(10) ) then
        write(chLine,'('' W-PAHs are turned on.  The photoionization'',
     1  '' problem is not correctly treated in this version.'')')
        call warnin( chLine )
      endif
*
*     remark that grains not present but energy density was low
      if(.not.lgDustOn.and.TEnerDen.lt.800. ) then
        write(chLine,'(''   Grains were not present but might '',
     1  ''survive in this environment (energy density temperature was''
     1  ,1p,e9.2,''K)'')') TEnerDen
        call notein( chLine )
      endif
*
*     call routine that will check age of cloud
      call CheckAge
*
*     He II Ly-a radiation pressure turned on with non-trivial O abund
      if( lgPresHeLya .and. xIonFracs(8,0)/hden.gt.1e-7 ) then
        write(chLine,'('' W-HeII Ly-a radiation pressure'',
     1  '' is on, and oxygen abundance is significant.''
     2  ,'' Bowen, Prad, not treated OK.'')')
        call warnin( chLine )
      endif
*
*     check on CaH and H-epsilon overlapping
*     need to do this since need to refer to lines arrays
      call chkCaHeps( totwid )
      if( totwid.gt.121. ) then
        write(chLine,'(''   H-eps and CaH overlap.'')')
        call notein( chLine )
      endif
*
*     warning that something was turned off
      if(.not.lgPhysOK) then
        write(chLine,'('' W-A physical process has been disabled.'')')
        call warnin( chLine )
      endif
*
*     check on lifetimes of [OIII] against photoionization, only for low den
      if( hden.lt.1e8 ) then
        if( r5007Max.gt. 0.0263 ) then
          write(chLine,'(''  !Photoionization of upper level of [OIII]''
     1    ,'' 5007 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r5007Max*100.
          call bangin( chLine )
        else if( r5007Max.gt. 0.0263/10. ) then
          write(chLine,'(''   Photoionization of upper level of [OIII]''
     1    ,'' 5007 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r5007Max*100.
          call notein( chLine )
        endif
        if( r4363Max.gt. 1.78 ) then
          write(chLine,'(''  !Photoionization of upper level of [OIII]''
     1    ,'' 4363 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r4363Max*100.
          call bangin( chLine )
        else if( r4363Max.gt. 1.78/10. ) then
          write(chLine,'(''   Photoionization of upper level of [OIII]''
     1    ,'' 4363 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r4363Max*100.
          call notein( chLine )
        endif
      endif
*
*     check whether total heating and cooling matched
*     >>chng 97 mar 28, added GrossHeat, heat in terms normally heat-cool
      error = abs(power-totcol) / ( ( power + totcol+GrossHeat)/2.)
      if( lgTSetOn ) then
        if( error.gt.0.05 ) then
          write(chLine,'(''  !Heating - cooling mismatch ='',F5.1,''%.''
     1    ,'' Caused by constant temperature assumption. '')')error*100.
          call bangin( chLine )
        endif
      else
        if( error.gt.0.05 .and. error.lt.0.2 ) then
          write(chLine,'('' C-Heating - cooling mismatch ='',F5.1,''%.''
     1    ,'' Whats wrong?'')')  error*100.
          call caunin( chLine )
        else if(  error.ge.0.2 ) then
          write(chLine,'('' W-Heating - cooling mismatch ='',1P,E10.2,
     1    '' Whats wrong????'')') error
          call warnin( chLine )
        endif
      endif
*
*     say if Ly-alpha photo of Ca+ excited levels was important
      if( Ca2RmLya.gt.0.01 ) then
        write(chLine,'(''   Photoionization of Ca+ 2D level by '',
     1  ''Ly-alpha reached '',F6.1,''% of the total rate out.'')')
     2  Ca2RmLya*100.
        call notein( chLine )
      endif
*
*     check if Lya alpha ever hotter than gas
      if( nLyaHot .gt.0 ) then
        if( TLyaMax/TeLyaMax.gt. 1.05 ) then
          write(chLine,'(''  !The excitation temp of Lya '',
     1    ''exceeded the electron temp, largest value was'',1p,e10.2,
     2    ''K (gas temp there was'',e9.2,''K, zone'',i4,'')'')')
     3    TLyaMax,TeLyaMax,nZTLaMax
          call bangin( chLine )
        endif
      endif
*
*     was line photoionization of hydrogen important
      hlmax(1) = 0.
      isav = 0
      do i=2,nhlvl
        if( hlmax(i) .gt. 0.001 ) then
          if( hlmax(i).gt.hlmax(1) ) then
            hlmax(1) = hlmax(i)
            isav = i
          endif
        endif
      end do
      if(isav.gt.0) then
         write(chLine,'(''   Hydrogen self ionization by alpha '',
     1   ''transitions reached '',F6.1,''% of the destruction rate for''
     2   ,'' level'',i3,''.'')') hlmax(1) * 100. , isav
         call notein( chLine )
      endif
*
*     check if line absorption heating was important
*
*     get all negative lines, check if line absorption significant heat source
*     this is used in "final" for energy budget print out
      call cdLine( 'Line' , 0 , SumNeg , absint , lgOK )
      if( .not.lgOK ) write(qq,'('' did not get sumneg cdLine'')')
*     this is total heating
      call cdLine( 'TotH' , 0 , GetHeat , absint , lgOK )
      if( .not.lgOK ) write(qq,'('' did not get GetHeat cdLine'')')
      if( GetHeat.gt.0. ) then
        SumNeg = SumNeg / GetHeat
        if( SumNeg.gt.0.1 ) then
          write(chLine,'(''  !Line absorption heating reached'',1p,
     1    e10.2,''% of the global heating.'')') SumNeg * 100.
          call bangin( chLine )
        else if( SumNeg.gt.0.01 ) then
          write(chLine,'(''   Line absorption heating reached'',1p,
     1    e10.2,''% of the global heating.'')') SumNeg * 100.
          call notein( chLine )
        endif
      endif
*
*     this is check of extra lines added with g-bar
      if( GBarMax .gt.0.1 ) then
        chLbl = chLineLbl( WindLine(1,ipMaxExtra) )
        write(chLine,'(''  !G-bar cooling lines reached'',1p,e10.2,
     1  ''% of the local cooling.  Line='',a10)') GBarMax * 100.,chLbl
        call bangin( chLine )
      else if( GBarMax.gt.0.01 ) then
        chLbl = chLineLbl( WindLine(1,ipMaxExtra) )
        write(chLine,'(''   G-bar cooling lines reached'',1p,e10.2,
     1  ''% of the local cooling.  Line='',a10)') GBarMax * 100.,chLbl
        call notein( chLine )
      endif
*
*     line absorption heating reached more than 10% of local heating?
*     heatlmax is largest heating(1,23)/htot
      if( heatlmax .gt.0.1 ) then
        if( levlmax.eq.1 ) then
*         main block of lines
          chLbl = chGetLbl( ipHeatlmax )
        else if( levlmax.eq.2 ) then
*         level 2 lines
          chLbl = chLineLbl( WindLine(1,ipHeatlmax) )
        else
          write(qq,'('' comment has insane levlmax,='',i5)')levlmax
        endif
        write(chLine,'(''  !Line absorption heating reached'',1p,e10.2,
     1  ''% of the local heating - largest by level'',i2,'' line '',
     2  a10)') heatlmax * 100. , levlmax , chLbl
        call bangin( chLine )
      else if( heatlmax.gt.0.01 ) then
        write(chLine,'(''   Line absorption heating reached'',1p,e10.2,
     1  ''% of the local heating.'')') heatlmax * 100.
        call notein( chLine )
      endif
*
*     check if charge transfer heating cooling was important
      if( HCharHeatMax .gt.0.05 ) then
        write(chLine,'(''  !Charge transfer heating reached'',1p,e10.2,
     1  ''% of the local heating.'')') HCharHeatMax * 100.
        call bangin( chLine )
      else if( HCharHeatMax .gt.0.005 ) then
        write(chLine,'(''   Charge transfer heating reached'',1p,e10.2,
     1  ''% of the local heating.'')') HCharHeatMax * 100.
        call notein( chLine )
      endif
      if( HCharCoolMax .gt.0.05 ) then
        write(chLine,'(''  !Charge transfer cooling reached'',1p,e10.2,
     1  ''% of the local heating.'')') HCharCoolMax * 100.
        call bangin( chLine )
      else if( HCharCoolMax .gt.0.005 ) then
        write(chLine,'(''   Charge transfer cooling reached'',1p,e10.2,
     1  ''% of the local heating.'')') HCharCoolMax * 100.
        call notein( chLine )
      endif
*
*     did Ly-alpha mase
      if( lgHLyaMased ) then
        write(chLine,'(''   Ly-alpha mased.'')')
        call notein( chLine )
      endif
*
*     did HeII mase?
      if( lgHeMase ) then
        write(chLine,'(''   Helium continuum mased.'')')
        call notein( chLine )
      endif
*
*     check whether excited states of helium were optically thick
      lgHe1thk = .false.
      lgHe2thk = .false.
      do i=2,5
        do j=i+1,6
          if( he1tau(j,i).gt.1. ) lgHe1thk = .true.
          if( he2tau(j,i).gt.1. ) lgHe2thk = .true.
        end do
      end do
      if( lgHe1thk ) then
        write(chLine,'(''   Some excited state HeI lines are thick.'')
     1  ')
        call notein( chLine )
      endif
      if( lgHe2thk ) then
        write(chLine,'(''   Some excited state HeII lines are thick.''
     1   )')
        call notein( chLine )
      endif
*
      if( hden.lt.1e7 ) then
*       check on IR fine structure lines
        lgThick = .false.
        tauneg = 0.
        alpha = 0.
        do i=1,nTauLines
*         define IR as anything longward of 1 micron
          if( TauLines(ipLnEnrWN,i).lt. 10 000. ) then
            if( TauLines(ipLnTauIn,i).gt.1. ) then
              lgThick = .true.
              alpha = max( alpha,TauLines(ipLnTauIn,i) )
            else if( TauLines(ipLnTauIn,i).lt.tauneg ) then
              tauneg = tauneg
              chLbl = chLineLbl( TauLines(1,i) )
            endif
          endif
        end do
*       now print results, were any fine structure lines optically thick?
        if( lgThick ) then
          write(chLine,'(''  !Some infrared fine structure lines '',
     1    ''are optically thick:  largest tau was'',1p,e10.2)') alpha
          call bangin( chLine )
        endif
*       did any fine structure lines mase?
        if( tauneg.lt.-0.01 ) then
          write(chLine,'(''  !Some fine structure lines mased:'',
     1    ''ion with smallest tau was'',a10,1p,e10.2)') chLbl,tauneg
          call bangin( chLine )
        endif
      endif
*
*     were any other lines masing?
      tauneg = 0.
      alpha = 0.
      do i=1,nTauLines
*       define UV as anything shortward of 1 micron
        if( TauLines(ipLnEnrWN,i).ge. 10 000. ) then
          if( TauLines(ipLnTauIn,i).lt.tauneg ) then
            tauneg = TauLines(ipLnTauIn,i)
            chLbl = chLineLbl( TauLines(1,i) )
          endif
        endif
      end do
*     did any lines mase?
      if( tauneg.lt.-0.01 ) then
        write(chLine,'(''  !Some lines mased: '',
     1  ''most negative ion and tau were:'',a10,1p,e10.2)') chLbl,tauneg
        call bangin( chLine )
      endif
*
      if( lgStatic.and.lgLastIt.and.(iter.eq.1 ) ) then
        write(chLine,'('' C-I must iterate when SPHERE STATIC is set.''
     1  )')
        call caunin( chLine )
        lgIterAgain = .true.
      endif
*
*     how important was induced two photon??
      if(xMax2Pht.gt.1.) then
        write(chLine,'(''  !Rate of induced H 2-photon emission '',
     1  ''reached '',1p,e9.2,'' s^-1'')') xMax2Pht
        call bangin( chLine )
      else if( xMax2Pht.gt.0.05 ) then
        write(chLine,'(''   Rate of induced H 2-photon emission '',
     1  ''reached '',1p,e9.2,'' s^-1'')') xMax2Pht
        call notein( chLine )
      endiF
*
*     how important was induced recombination?
      if(FracInd.gt.0.01) then
        write(chLine,'(''   Induced recombination was '',
     1  F5.1,''% of the total for H level'',i3)') FracInd*100. , ndclev
        call notein( chLine )
      endiF
*
      if(fbul.gt.0.01) then
         write(chLine,'(''   Stimulated emission was'',F6.1,
     1   ''% of the total for H transition'',i3,'' -'',i3)') 
     2   fbul*100. , nbul+1 , nbul
         call notein( chLine )
      endif
*
*     check whether FeII destruction of La was important
      call cdLine( 'Fe 2' , 1216 , fedest , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find Fe ii Lya'')')
      call cdLine( 'TOTL' , 1216 , alpha , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find Lya'')')
      if( alpha.gt.0. ) then
        ratio = fedest/(fedest+alpha)*100.
        if( ratio.gt.10. ) then
          write(chLine,'(''  !FeII destruction of Ly-a removed '',
     1    F5.1,''% of the line.'')') ratio
          call bangin( chLine )
        else if( ratio.gt.0.1 ) then
          write(chLine,'(''   FeII destruction of Ly-a removed '',
     1    F5.1,''% of the line.'')') ratio
          call notein( chLine )
        endif
      endif
*
      call cdLine( 'H-CT' , 6563 , relhm , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Comment did not find H-CT H-alpha'')')
      if( HBeta.gt.0. ) then
        if( relhm/HBeta.gt.0.01 ) then
          write(chLine,'(''  !Mutual neutralization production of H-'',
     1    ''alpha was significant.'')')
          call bangin( chLine )
        endif
      endif
*
*     note about very high population in H n=2 rel to ground
      if( lgHiPop2 ) then
         write(chLine,'(''   The population of H n=2 reached'',1P,
     1   E9.2,'' relative to the ground state.'')') pop2mx
         call notein( chLine )
      endif
*
*     check where diffuse emission error
      if( CaseBCheck.gt.1.5 ) then
         write(chLine,'(''   Ratio of computed diffuse emission to ''
     1   ,'' case B reached'',1P,E9.2)') CaseBCheck
         call notein( chLine )
      endif
*
      if( thist.gt.1e9 ) then
        if( thist.gt.5e9 ) then
          write(chLine,'('' W-Electrons were relativistic;'',
     1    '' High TE='',1P,E9.2)') thist
          call warnin( chLine )
        else
          write(chLine,'('' C-Electrons were mildly relativistic;'',
     1    '' High TE='',1P,E9.2)') thist
          call caunin( chLine )
        endif
      endif
*
      rate = TimeErode * 2e-26
      if( rate.gt.1e-35 ) then
*        2E-26 is roughly cross section for photoerosion
*        see Boyd and Ferland ApJ Let 318, L21.
         ts = (1. / rate ) / 3e7
         if( ts.lt. 1e3 ) then
            write(chLine,'(''  !Timescale-photoerosion of Fe='',1P,E8.2,
     1      ''yr'')') ts
            call bangin( chLine )
         else if( ts.lt.1e9 ) then
            write(chLine,'(''   Timescale-photoerosion of Fe='',1P,E8.2,
     1      ''yr'')') ts
            call notein( chLine )
         endif
      endif
*
*     check whether Compton heating was significant
      comfrc = comtot / power
      if( comfrc .gt.0.01 ) then
         write(chLine,'(''   Compton heating was '',F5.1,''% of the '',
     1   ''total.'')') comfrc*100.
         call notein( chLine )
      endif
*
*     check on relative importance of induced compton heating
      if( comfrc.gt.0.01.and.cinrat.gt.0.05 ) then
         write(chLine,'(''  !Induced Compton heating was '',1P,E9.2,
     1   '' of the total Compton heating.'')') cinrat
         call bangin( chLine )
      endif
*
*     check whether equilibrium timescales are short rel to Hubble time
      if( tcmptn.gt.5e17 ) then
         if( comfrc.gt.0.05 ) then
            write(chLine,'('' C-Compton cooling is significant and '',
     1      ''the equilibrium timescale ('',1p,e9.2,''s) is longer '',
     1      ''than the Hubble time.'')') tcmptn
            call caunin( chLine )
         else
            write(chLine,'(''   Compton cooling '',
     1      ''equilibrium timescale ('',1p,e9.2,''s) is longer '',
     1      ''than Hubble time.'')') tcmptn
            call notein( chLine )
         endif
      endif
*
      if( ttherm.gt.5e17 ) then
         write(chLine,'('' C-Thermal equilibrium timescale longer '',
     1   ''than Hubble time, ='',1P,E10.2,''s'')') ttherm
         call caunin( chLine )
      endif
*
*     check whether model large relative to Jeans length
*     DMEAN is mean density (gm per cc)
*     mean temp is weighted by mass density
      if( log10(depth).gt.rjnmin ) then
*       AJMIN is minimum Jeans mass, log in grams
        aj = 10.**( ajmmin - log10(solarm) )
        if( chCPres.eq.'CPRE' ) then
          write(chLine,'('' C-Cloud thicker than smallest Jeans '',
     1    ''length='',1P,E8.2,''cm; stability problems? '',
     2    ''(smallest Jeans mass='', E8.2,''Mo)'')') 10.**rjnmin,aj
          call caunin( chLine )
        else
          write(chLine,'(''   Cloud thicker than smallest Jeans '',
     1    ''length='',
     1    1P,E8.2,''cm; stability problems? (smallest Jeans mass='',
     2    E8.2,''Mo)'')') 10.**rjnmin,aj
          call notein( chLine )
        endif
      endif
*
*     check if constant pressure, but it wasn't
      if( chCPres.eq.'CPRE' ) then
        if( phi/plow.gt.1.50 ) then
          write(chLine,'('' C-Sum of gas+line rad pressure ranged from''
     1    ,1P,E10.2,'' to '',E10.2,'' in a constant pressure model.'')')
     2    plow , phi
          call caunin( chLine )
        else if( phi/plow.gt.1.20 ) then
          write(chLine,'(''  !Sum of gas+line rad pressure ranged from''
     1    ,1P,E10.2,'' to '',E10.2,'' in a constant pressure model.'')')
     2    plow , phi
          call bangin( chLine )
        else if( phi/plow.gt.1.05 ) then
          write(chLine,'(''   Sum of gas+line rad pressure ranged from''
     1    ,1P,E10.2,'' to '',E10.2,'' in a constant pressure model.'')')
     2    plow , phi
          call notein( chLine )
        endif
      endif
*
*     check whether grains too hot to survive
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
          if( tgrmax(nd).gt.sublimat(nd) ) then
            write(chLine,'('' W-Maximum temperature of grain '',A10,
     1      '' was'',1P,E10.2,''K, above its sublimation temperature,'',
     2      e10.2,''K.'')')
     2      chDstLab(nd) , tgrmax(nd),sublimat(nd)
            call warnin( chLine )
          else if( tgrmax(nd).gt.sublimat(nd)*0.9 ) then
            write(chLine,'('' C-Maximum temperature of grain '',A10,
     1      '' was'', 1P,E10.2,''K, near its sublimation temperature,'',
     2      e10.2,''K.'')')
     2      chDstLab(nd) , tgrmax(nd),sublimat(nd)
            call caunin( chLine )
          endif
        endif
      end do
*
      if( lgNegGrnDrg ) then
        write(chLine,'(''  !Grain drag force <0.'')')
        call bangin( chLine )
      endif
*
*     is photoelectric heating of gas by photioniz of grains important
      if( dphmax.gt.0.05 ) then
        write(chLine,'(''   Local grain-gas photoelectric '',
     1  ''heating rate reached '',F5.1,''% of the total.'')'
     2   ) dphmax*100.
        call notein( chLine )
      endif
*
      if( TotalDustHeat/power .gt. 0.01 ) then
        write(chLine,'(''   Global grain photoelectric heating of '',
     1  ''gas was'',F5.1,''% of the total.'')') TotalDustHeat/power*100.
        call notein( chLine )
        if( TotalDustHeat/power .gt. 0.25 ) then
          write(chLine,'(''  !Grain photoelectric heating is VERY '',
     1    ''important.'')')
          call bangin( chLine )
        endif
      endif
*
*     grain-gas collis cooling of gas
      if( dclmax.gt.0.05 ) then
         write(chLine,'(''   Local grain-gas '',
     1   ''cooling of gas rate reached '',F5.1,''% of the total.'')'
     2    ) dclmax*100.
         call notein( chLine )
      endif
*
*     check whether photodissociation of H_2^+ molecular ion was important
      if( h2pmax.gt.0.10 ) then
         write(chLine,'(''  !The local H2+ photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total heating.'')')
     2   h2pmax*100.
         call bangin( chLine )
      else if( h2pmax.gt.0.01 ) then
         write(chLine,'(''   The local H2+ photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total heating.'')')
     2   h2pmax*100.
         call notein( chLine )
      endif
*
*     check whether photodissociation of molecular hydrogen (H2)was important
      if( h2dfrc.gt.0.05 ) then
         write(chLine,'(''   The local H2 photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total.'')')
     2   h2dfrc*100.
         call notein( chLine )
      endif
*
      if( h2dtot/power .gt. 0.01 ) then
         write(chLine,'(''   Global H2 photodissociation heating of '',
     1   ''gas was'',F5.1,''% of the total.'')') h2dtot/power*100.
         call notein( chLine )
         if( h2dtot/power .gt. 0.25 ) then
            write(chLine,'(''   H2 photodissociation heating is VERY '',
     1      ''important.'')')
            call notein( chLine )
         endif
      endif
*
*     check whether photodissociation of carbon monoxide (co) was important
      if( codfrc.gt.0.25 ) then
         write(chLine,'(''  !Local CO photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total.'')')
     2   codfrc*100.
         call bangin( chLine )
      else if( codfrc.gt.0.05 ) then
         write(chLine,'(''   Local CO photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total.'')')
     2   codfrc*100.
         call notein( chLine )
      endif
*
      if( codtot/power .gt. 0.01 ) then
         write(chLine,'(''   Global CO photodissociation heating of '',
     1   ''gas was'',F5.1,''% of the total.'')') codtot/power*100.
         call notein( chLine )
         if( codtot/power .gt. 0.25 ) then
            write(chLine,'(''   CO photodissociation heating is VERY '',
     1      ''important.'')')
            call notein( chLine )
         endif
      endif
*
      if( lgEdnGTcm ) then
        write(chLine,'(''   Energy density of radiation field was '',
     1  ''greater than the Compton temperature. Is this physical?'')')
        call notein( chLine )
      endif
*
*     was cooling due to induced recombination important?
      if( cintot/power.gt.0.01) then
        write(chLine,'(''   Induced recombination'',
     1  '' cooling was'',F5.1,''% of the total.'')') cintot/power*100.
        call notein( chLine )
      endif
*
*     check whether free-free heating was significant
      if( ffhtot/power.gt.0.1 ) then
        write(chLine,'(''  !Free-free heating was'',F5.1,''% of the '',
     1  ''total.'')') ffhtot/power*100.
        lgFFimp = .true.
        call bangin( chLine )
      else if( ffhtot/power.gt.0.01 ) then
        write(chLine,'(''   Free-free heating was'',F5.1,''% of the '',
     1  ''total.'')') ffhtot/power*100.
        lgFFimp = .true.
        call notein( chLine )
      else
        lgFFimp = .false.
      endif
*
*     was heating due to H- absorption important?
      if( hmitot/power.gt.0.01 ) then
        write(chLine,'(''   H- absorption heating'',
     1  '' was'',F5.1,''% of the total.'')') hmitot/power*100.
        call notein( chLine )
      endif
*
*     water desruction rate was zero
      if( lgH2Ozer ) then
        write(chLine,'(''   Water destruction rate zero.'')')
        call notein( chLine )
      endif
*
*     numerical instability in matrix inverson routine
      if( negoi.gt.0 ) then
        write(chLine,'('' C-OI negative level populations'',
     1  I4,'' times.'')') negoi
        call caunin( chLine )
      endif
*
*     numerical instability in matrix inverson routine
      if( nFe2Neg.gt.0 ) then
        write(chLine,'('' C-FeII negative level populations'',
     1  I4,'' times.'')') nFe2Neg
        call caunin( chLine )
      endif
*
*     check for negative optical depths,
*     optical depth in excited state helium lines
      lgMaser = .false.
      small = 0.
      do i=1,nhlvl-1
        do j=i+1,nhlvl
          if( htau(j,i).lt.-0.05 ) then
            small = min( small , htau(j,i) )
            lgMaser = .true.
            imas = 100 * j + i
          endif
        end do
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some H lines mased.'',
     1  ''  Smallest tau='',1P,E10.2,i6)') small, imas
        call bangin( chLine )
      endif
*
*     check for negative optical depths in He atom
*     optical depth in excited state helium lines
      lgMaser = .false.
      small = 0.
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
          if( he1tau(j,i).lt.-0.05 ) then
            small = min( small , he1tau(j,i) )
            lgMaser = .true.
            imas = 100 * j + i
          endif
        end do
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some HeI lines mased.'',
     1  ''  Smallest tau='',1P,E10.2,i6)') small, imas
        call bangin( chLine )
      endif
*
*     check for negative optical depths in He ion
*     optical depth in excited state helium lines
      lgMaser = .false.
      small = 0.
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          if( he2tau(j,i).lt.-0.05 ) then
            small = min( small , he2tau(j,i) )
            lgMaser = .true.
            imas = 100 * j + i
          endif
        end do
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some HeII lines mased.'',
     1  ''  Smallest tau='',1P,E10.2,i6)') small, imas
        call bangin( chLine )
      endif
*
*     check for negative opacities
      if( lgOpacNeg ) then
        write(chLine,'(''  !Some opacities were negative - the'',
     1  '' SET NEGOPC command will punch which ones.'')')
        call bangin( chLine )
      endif
*
*     now check continua
      lgMaser = .false.
      small = 0.
      do i=1,9
        if( tauabs(ipHn(i),1).lt.-0.001 ) then
          small = min( small , tauabs(ipHn(i),1) )
          lgMaser = .true.
          imas = i
        endif
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some H continua optical depths were'',
     1  ''negative; smallest='',1P,E10.2,'' level='',i3)') small , imas
        call bangin( chLine )
      endif
*
*     check whether any continuum optical depths are negative
      nneg = 0
      tauneg = 0.
      do i=1,nflux
        if( tauabs(i,1).lt.-0.001 ) then
          nneg = nneg + 1
*         only remember the smallest freq, and most neg optical depth
          if(nneg.eq.1) freqn = anu(i)
          tauneg = min( tauneg,tauabs(i,1) )
        endif
      end do
      if( nneg.gt.0 ) then
         write(chLine,'(''  !Some continuous optical'',
     1     '' depths <0.  The lowest freq was'',
     2     1P,E10.3,'' Ryd, and a total of'',I4)') freqn , nneg
         call bangin( chLine )
         write(chLine,'(''  !The smallest optical depth was'',
     1   1p,e10.2)') tauneg
         call bangin( chLine )
      endif
*
*     say if Balmer continuum optically thick
      if( tauabs(ipHn(2),1).gt.0.05 ) then
         write(chLine,'(''   The Balmer continuum ''
     1   ,''optical depth was'',1P,E9.2,''.'')') tauabs(ipHn(2),1)
         call notein( chLine )
      endif
*
*     was correction for stimulated emission significant?
      if( stimax(1).gt.0.02 .and.tauabs(ipHn(1),1).gt.0.2 ) then
         write(chLine,'(''   The Lyman continuum stimulated emission ''
     1   ,''correction to optical depths reached'',1P,E9.2,''.'')')
     2   stimax(1)
         call notein( chLine )
      else if( stimax(2).gt.0.02 .and.tauabs(ipHn(2),1).gt.0.1 ) then
         write(chLine,'(''   The Balmer continuum stimulated emission ''
     1   ,''correction to optical depths reached'',1P,E9.2,''.'')')
     2   stimax(2)
         call notein( chLine )
      endif
*
*     say if Paschen continuum optically thick
      if( tauabs(ipHn(3),1) .gt.0.2 ) then
         write(chLine,'(''   The Paschen continuum optical depth was'',
     1   1P,E10.2,''.'')') tauabs(ipHn(3),1)
         call notein( chLine )
      endif
*
*     some comments about near IR total optical depth
      if( tauabs(1,1).gt.1. ) then
         write(chLine,'(''   The continuum optical depth at the lowest''
     1   ,'' energy considered (E='',1P,
     1   E10.3,'' Ryd) was '',E10.3,''.'')') anu(1) , tauabs(1,1)
         call notein( chLine )
      endif
*
*     comment if optical depth to Rayleigh scattering is big
*     cs from VAL 76
      if( chi*7e-24 .gt. 0.01 ) then
         write(chLine,'(''   The optical depth to'',
     1   '' Rayleigh scattering at 1300A is'',1P,E9.2)') chi*6.71E-24
         call notein( chLine )
      endif
*
      if( ch2pls*7e-18 .gt. 0.01 ) then
         write(chLine,'(''   The optical depth to''
     1   ,'' the H2+ molecular ion is'',1P,E9.2)') ch2pls*7e-18
         call notein( chLine )
      endif
*
*     warn if optically thick to H- absorption
      if( thmin.gt.0.01 ) then
         write(chLine,'(''   Optical depth to negative hydrogen ion is''
     1   ,1P,e10.2)') thmin
         call notein( chLine )
      endif
*
*     say if 3-dody rec coef function outside range of validity
*     tripped if te/z**2 < 100 or approx 10**13: => effect >50% of radiative
*     other intergers defined in source for da
      if( ifail.gt.0 .and. ifail.le.10 ) then
         write(chLine,'(''   3 body rec coef outside range'',I4)') ifail
         call notein( chLine )
      else if( ifail.gt.10 ) then
         write(chLine,'('' C-3 body rec coef outside range'',I4)') ifail
         call caunin( chLine )
      endif
*
*     check whether energy density less than background
      if( TEnerDen.lt.2.6 ) then
         write(chLine,'(''  !Incident radiation field '',
     1   ''energy density is less than 2.7K.  Add background with ''
     2   ,''FIREBALL command.'')')
         call bangin( chLine )
      endif
*
*     incident radiation field is less than Habing ISM field
      if( lgHabing ) then
         write(chLine,'(1X,'' !The intensity of the incident '',
     1   ''radiation field is less than 10 times the Habing'',
     1   '' diffuse ISM field.  Is this OK?'')')
         call bangin( chLine )
      endif
*
*     check whether cosmic rays on, but model thick to them
      if( cryden.gt.0. .and. (chi/10. + chii).gt.1e23 ) then
         write(chLine,'('' C-Model is thick to cosmic rays, which are'',
     1   '' on.'')')
         call caunin( chLine )
      endif
*
*     was ionization rate less than cosmic ray ionization rate in ISM?
      if( cryden.eq.0. .and. hgamnc(1).lt.1e-17 ) then
         write(chLine,'(''   Ionization rate fell below background ''
     1   ,''cosmic ray ionization rate.  Should this be added too?'')')
         call notein( chLine )
      endif
*
*     more than 10% of H is in the H2 molecule
      if( BiggestH2.gt.0.1 ) then
         write(chLine,'(''  !A large amount of the hydrogen is '',
     1   ''molecular, the fraction reached '',F5.1,''%.'')')
     2   min(1.,BiggestH2)*100.
         call bangin( chLine )
      else if( BiggestH2.gt.1e-3 ) then
         write(chLine,'(''   The H2/H molecular fraction reached'',1P,
     1   e9.2,''%.'')') BiggestH2*100.
         call notein( chLine )
      endif
*
*     how much carbon is molecular?
      if( CarMolFrac.gt.0.1 ) then
         write(chLine,'(''  !A large amount of the carbon is molecular''
     1   ,'', fraction reached '',F5.1,''%'')') min(1.,CarMolFrac)*100.
         call bangin( chLine )
      else if( CarMolFrac.gt.1e-3 ) then
         write(chLine,'(''   The carbon molecular fraction reached'',1P,
     1   e9.2,''%'')') CarMolFrac*100.
         call notein( chLine )
      endif
*
*     brems optical depth
      if( tff.gt.0.09 ) then
        write(chLine,'(''  !The cloud is optically thick at '',
     1  ''optical wavelengths, extending to'',1P,E10.3,'' Ryd ='',
     2  e10.3,''A'')') tff , rydlam / tff
        call bangin( chLine )
      else if ( tff.gt.0.009 ) then
        write(chLine,'(''   The continuum of the computed structure '',
     1  ''may be optically thick in the near infrared.'')')
        call notein( chLine )
      endif
*
*     did model run away to very large radius?
      if( radius.gt.1e23 .and. radius/rinner.gt.10. ) then
        write(chLine,
     1  '(''   Is an outer radius of'',1P,E9.2,'' reasonable?'')')
     2  radius
        call notein( chLine )
      endif
*
*     lgPradCap is true if radiation pressure was capped on first iteration
*     also check that this is a constant total pressure model
      if( lgPradCap.and. (chCPres.eq.'CPRE').and.lgRadPresON ) then
         write(chLine,'(''   Radiation '',
     1   ''pressure kept below gas pressure on this iteration.'')')
         call notein( chLine )
      endif
*
      if( RadBetaMax.gt.0.5 ) then
        if( iprdmx.eq.1 ) then
          write(chLine,'(''   The ratio of radiation to gas pressure''
     1    ,'' reached '',1P,E9.2,''.  Caused by Lyman alpha.'',I3)')
     2    RadBetaMax
          call notein( chLine )
        else
          write(chLine,'(''   The ratio of radiation to gas pressure''
     1    ,'' reached '',1P,E9.2,''.  Caused by line number'',I3)')
     2    RadBetaMax, iprdmx
          call notein( chLine )
        endif
      endif
*
      if( telec.gt.0.05 .and. telec.le.1.0 )  then
        write(chLine,'(''   The optical depth to electron scattering ''
     1  ,''was'',1P,E10.2)')telec
        call notein( chLine )
      else if( telec.gt.1.0 .and. telec.lt.5. ) then
        write(chLine,'('' C-The model is optically thick to electron'',
     1  '' scattering; tau='',1P,E9.2)') telec
        call caunin( chLine )
      else if( telec.ge.5. ) then
        write(chLine,'('' W-The model is optically thick to electron'',
     1  '' scattering; tau='',1P,E9.2)') telec
        call warnin( chLine )
      endif
*
*     heavy element molecules had negative poppulations
      if( lgComNeg .and. CarMolFrac.gt.0.5 ) then
        write(chLine,'(''  !Populations of heavy element molecules '',
     1  ''were negative because of large CO population.'')')
        call bangin( chLine )
      else if( lgComNeg ) then
        write(chLine,'('' C-Populations of heavy element molecules '',
     1  ''were negative; CO, H2O, etc populations may not be correct.''
     2  )')
        call caunin( chLine )
      endif
*
*     check on convergence of hydrogen lines
      if( htau(3,2).gt.0.2) then
        differ = abs(1.- htau(3,2)*DoubleTau/htlim(3,2)  ) * 100.
*       check whether H-alpha optical depth changed by much on last iteration
*       no tolerance can be finer than autocv, the tolerance on the
*       iterate to convergence comamnd.  It is 15%
        if(  lgLastIt .and.  htau(3,2).gt.0.8  .and. differ.gt.20. .and.
     1    windv.eq.0. ) then
          write(chLine,'('' C-This is the last iteration and H(a) '',
     1    ''optical depth changed by'',F6.1,''% (was '',1P,E9.2,
     2    ''). Try another iteration.'')') differ , htlim(3,2)
          call caunin( chLine )
          lgIterAgain = .true.
        endif
*       only check on Lya convergence if Balmer lines are thick
        if( htau(2,1).gt.0. ) then
          differ = abs(1.- htau(2,1)*DoubleTau/htlim(2,1)  ) * 100.
*         check whether h-alpha optical depth changed by much on last iteration
*         no tolerance can be finer than autocv, the tolerance on the
*         iterate to convergence comamnd.  It is 15%
          if( lgLastIt .and.  htau(2,1).gt.0.8  .and. differ.gt.25..and.
     1      windv.eq.0. ) then
            write(chLine,'('' C-This is the last iteration and Ly(a) '',
     1      ''optical depth changed by'',F7.0,''% (was '',1P,E9.2,
     2      ''). Try another iteration.'')') differ , htlim(2,1)
            call caunin( chLine )
            lgIterAgain = .true.
          endif
        endif
      endif
*
      if( he1tau(2,1).lt.1e3 .and. lgHe1ON .and.
     1  (he1tau(2,1)-TAddHeI) .gt.0.5 ) then
        differ = abs(1.- he1tau(2,1)*DoubleTau/he1lim(2,1) ) * 100.
*       check whether he 1 h-alpha optical depth converged
        if(  lgLastIt .and.  he1tau(2,1).gt.0.8  .and. differ.gt.10.
     1    .and.  windv.eq.0. ) then
          write(chLine,'('' C-This is the last iteration and HeI(Lya) ''
     1    ,''optical depth changed by'',F6.1,''% (was '',1P,E9.2,
     2    ''). Try another iteration'')') differ , he1lim(2,1)
          call caunin( chLine )
          lgIterAgain = .true.
        endif
      endif
*
      if( he2tau(2,1).lt.1e3 .and. lgHe2ON ) then
        differ = abs(1.- he2tau(2,1)*DoubleTau/he2lim(2,1) ) * 100.
*       check whether he 2 h-alpha optical depth converged
        if(  lgLastIt .and.  he2tau(2,1).gt.0.8  .and. differ.GT.10.
     1  .and.  windv.eq.0. ) then
          write(chLine,'('' C-This is the last iteration and HeII(''
     1    ,''Lya) optical depth changed by'',F6.1,''% (was '',1P,E9.2,
     2    ''). Try another iteration'')') differ , he2lim(2,1)
          call caunin( chLine )
          lgIterAgain = .true.
        endif
      endif
*
*     check whether sphere was set if dr/r large
      if( radius/rinner.gt.2. .and. .not.lgSphere ) then
        write(chLine,'('' C-R(out)/R(in)='',1P,E10.2,
     1  '' and SPHERE was not set.'')')radius/rinner
        call caunin( chLine )
      endif
*
*     check if thin in Lyman continuum, and assumed thick
      if( tauabs(ipHn(1),1).lt.2. .and. tauabs(ipHn(1),2) .gt.3.
     1  .and. lgLastIt .and. (.not.lgCaseb) ) then
        write(chLine,'('' C-The Lyman continuum is thin, and I '',
     2  ''assumed that it was thick.  Try another iteration.'')')
        call caunin( chLine )
        lgIterAgain = .true.
      endif
*
*     check if thin in helium continua, but assumed to be thick
      if( lgLastIt ) then
        if( tauabs(nhe2(1),1).lt.2. .and. tauabs(nhe2(1),1).gt.2. .and.
     1  nflux.gt.nheii ) then
          write(chLine,'('' C-The HeII continuum is thin and I '', 
     1    ''assumed that it was thick.  Try another iteration.'')')
          call caunin( chLine )
          lgIterAgain = .true.
        endif
        if( tauabs(nhe1(1),1).lt.2. .and. tauabs(nhe1(1),1).gt.2. .and.
     1  nflux.gt.nhei1 ) then
          write(chLine,'('' C-The HeI continuum is thin and I '',
     1    ''assumed that it was thick.  Try another iteration.'')')
          call caunin( chLine )
          lgIterAgain = .true.
        endif
      endif
*
*     check whether column density changed by much on this iteration
      if( iter.gt.1 ) then
        if( ColDenSav(iter-1).le.0. ) then
          write(qq,'('' ColDenSav is insane in comment.'')')
          call ShowMe
          stop
        endif
        differ = abs( 1.-colden/ColDenSav(iter-1) )
        if( differ.gt.0.1 .and. differ.le.0.3 ) then
          write(chLine,'(''   The column density changed by '',
     1    1p,e10.2,''% between this and previous iteration.'')')
     3    differ*100.
          call notein( chLine )
        else if( differ.gt.0.3 ) then
          if( lgLastIt ) then
            write(chLine,'(''  !The column density changed by '',
     1      1p,e10.2,''% and this is the last iteration.  '',
     2      ''What happened?'')')
     3      differ*100.
            call bangin( chLine )
          else
            write(chLine,'(''  !The column density changed by '',
     1      1p,e10.2,''%  What happened?'')')
     3      differ*100.
            call bangin( chLine )
          endif
        endif
      endif
*
*     say if rad pressure caused by la and la optical depth changed too much
      differ = abs(1.-  htau(2,1)/htlim(2,1)  ) * 100.
      if( lgLastIt .and. RadBetaMax.gt.0.1 .and. differ.gt.50. .and.
     1 iprdmx.eq.1 .and. lgRadPresON .and.windv.eq.0. ) then
         write(chLine,'(1X,''C-This is the last iteration, radiation '',
     1   ''pressure was significant, and the L-a optical depth '',
     2   ''changed by '',F7.2,''% (was'',1P,E10.2,'')'')') differ,
     3   htlim(2,1)
         call caunin( chLine )
      endif
*
*     say if la rad pressure capped by thermalization length
      if( lgPradDen ) then
         write(chLine,'(3X,
     1   ''Line radiation pressure capped by thermalization length.'')')
         call notein( chLine )
      endif
*
*     print te failures
      nline = min( nfail , 10 )
      if( nfail .ne. 0 ) then
        if( failmx.lt.0.1 ) then
          write(chLine,'(3X,''There were'',I4,
     1    '' minor temperature failures, the zones were''
     2    ,12I4)') nfail,(ifailz(i),i=1,nline)
          call notein( chLine )
        else
          write(chLine,'(''  !There were'',I4,
     1    '' temperature failures, and some were large.'',
     2    '' The largest was'',F6.1,''%.  What happened?'')')
     2     nfail,failmx*100.
          call bangin( chLine )
          write(chLine,'(''  !The zones were'',12I4)')
     1    (ifailz(i),i=1,nline)
          call bangin( chLine )
          if( testr(1).gt.8e4.and. te .lt.6E5 ) then
            write(chLine,'(''  !I think they may have been caused by'',
     1      '' the change from hot to nebular gas'',
     2      '' phase.  The physics of this is unclear.'')')
            call bangin( chLine )
          endif
        endif
      endif
* 
*     check for temperature jumps
      BigJump = 0.
      do i=2,nzone
        big = abs(1.-testr(i-1)/testr(i))
        if( big .gt.BigJump ) then
          j = i
          BigJump = big
        endif
      end do
      if( BigJump .gt.0.4 ) then
        write(chLine,'('' C-A temperature discontinuity occurred at '',
     1  ''zone'',i4,'' from'',1p,e9.2,''K to'',e9.2,''K.'')')
     2  j , testr(j-1) , testr(j)
        call caunin( chLine )
      else if( BigJump.gt.0.2 ) then
        write(chLine,'(''  !A temperature discontinuity occurred at '',
     1  ''zone'',i4,'' from'',1p,e9.2,''K to'',e9.2,''K.'')')
     2  j , testr(j-1) , testr(j)
        call bangin( chLine )
      endif
*
*     check for largest error in local electron density
      if( abs(BigEdenError).gt.EdenError ) then
*       this only produces a warning if not the very last zone
        if( abs(BigEdenError).gt.EdenError*10..and. nzEdenBad.ne.nzone)
     1    then
          write(chLine,'('' W-The local error in the electron density'',
     1    '' reached'',f5.1,''% at zone'',i5)') BigEdenError*100,
     2    ipEdenError
          call warnin( chLine )
        else if( abs(BigEdenError).gt.EdenError*5. ) then
          write(chLine,'('' C-The local error in the electron density'',
     1    '' reached'',f5.1,''% at zone'',i5)') BigEdenError*100,
     2    ipEdenError
          call caunin( chLine )
        else
          write(chLine,'(''   The local error in the electron density'',
     1    '' reached'',f5.1,''% at zone'',i5)') BigEdenError*100,
     2    ipEdenError
          call notein( chLine )
        endif
      endif
* 
*     check for temperature oscillations
      BigJump = 0.
      do i=2,nzone-1
        big = (testr(i-1)-testr(i)) /testr(i)
        bigm = (testr(i)-testr(i+1)) /testr(i)
        if( big*bigm.lt.0. .and.
     1    min(abs(bigm),abs(big)).gt.BigJump) then
          j = i
          BigJump = min(abs(bigm),abs(big))
        endif
      end do
      if( BigJump .gt.0.1 ) then
        write(chLine,'('' C-A temperature oscillation occurred ''
     1  ,''at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,'' to '',e9.2,
     2  '' to'',e9.2)')
     2  j , BigJump*100.,testr(j-1) , testr(j) , testr(j+1)
        call caunin( chLine )
      else if( BigJump.gt.0.3 ) then
        write(chLine,'(''  !A temperature oscillation occurred ''
     1  ,''at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,'' to '',e9.2,
     2  '' to'',e9.2)')
     2  j , BigJump*100.,testr(j-1) , testr(j) , testr(j+1)
        call bangin( chLine )
      endif
*
*     check for eden oscillations
      if( chCPres.eq.'CDEN' ) then
        BigJump = 0.
        do i=2,nzone-1
          big = (ednstr(i-1)-ednstr(i)) /ednstr(i)
          if( abs(big).lt.EdenError ) big = 0.
          bigm = (ednstr(i)-ednstr(i+1)) /ednstr(i)
          if( abs(bigm).lt.EdenError ) bigm = 0.
          if( big*bigm.lt.0. .and.
     1      abs(ednstr(i-1)-ednstr(i) )/ednstr(i).gt.BigJump) then
            j = i
            BigJump = abs(ednstr(i-1)-ednstr(i)) /ednstr(i)
          endif
        end do
        if( BigJump .gt.EdenError*10. ) then
          write(chLine,'('' C-An electron density oscillation ''
     1    ,''occurred at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,
     2    '' to '',e9.2,'' to'',e9.2)')
     2    j , BigJump*100.,ednstr(j-1) , ednstr(j) , ednstr(j+1)
          call caunin( chLine )
        else if( BigJump.gt.EdenError*3. ) then
          write(chLine,'(''  !An electron density oscillation occurred''
     1    ,'' at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,'' to '',e9.2
     2    ,'' to'',e9.2)')
     2    j , BigJump*100.,ednstr(j-1) , ednstr(j) , ednstr(j+1)
          call bangin( chLine )
        endif
      endif
*
*     say if te fell too low for matrix formalism
      if( nhlo.ne.0 ) then
         if( htau(3,2).gt.1. ) then
            write(chLine,'('' C-Temp or ion too low and matrix ''
     1      ,''not used for H.  Low den Case B assumed, BUT lines are''
     2      ,'' thick.'',I5,'' THLO='',1P,E10.3)') nhlo , thlo
            call caunin( chLine )
         else if( hden.gt.1e7 ) then
            write(chLine,'('' C-Temp or ion too low and matrix not ''
     1      ,''used for H in some zones. Low density Case B assumed.'',
     1      I5,'' THLO='' ,1P,E10.3)') nhlo , thlo
            call caunin( chLine )
         else
            write(chLine,'(''   Temp or ion too low and matrix not '',
     1      ''used for H in some zones. Low density Case B assumed.'',
     2      I5,'' THLO='',1P,E10.3)') nhlo , thlo
            call notein( chLine )
         endif
      endif
*
      if( nhe1lo.ne.0 ) then
         if( hden.gt.1e7 ) then
            write(chLine,'('' C-Temp too low and matrix not used for ''
     1      ,''He singlets in some zones. Low density Case B assumed.''
     2      ,I5,'' THE1LO='',1P,E10.3)') nhe1lo , the1lo
            call caunin( chLine )
         else
            write(chLine,'(''   Temp too low and matrix not used for ''
     1      ,''He singlets in some zones. Low density Case B assumed.''
     2      ,I5,'' THE1LO='',1P,E10.3)') nhe1lo , the1lo
            call notein( chLine )
         endif
      endif
*
      if( nhe2lo.ne.0 ) then
        if( hden.gt.1e7 ) then
          write(chLine,'('' C-Temp too low and matrix not used for ''
     1    ,''He ion in some zones. Low density Case B assumed.'',I5,
     2    '' THE2LO='',1P,E10.3)') nhe2lo , the2lo
          call caunin( chLine )
        else
          write(chLine,'(''   Temp too low and matrix not used for ''
     1    ,''He ion in some zones. Low density Case B assumed.'',I5,
     2    '' THE2LO='',1P,E10.3)') nhe2lo , the2lo
        call notein( chLine )
        endif
      endif
*
*     final prinout of warnings, cautions, notes,
      call cdNwcns( nw , nc , nn , ns , i, j )
      if( nw .gt. 0 ) then
        lgWarngs = .true.
      else
        lgWarngs = .false.
      endif
*
      if( nc .gt. 0 ) then
        lgCautns = .true.
      else
        lgCautns = .false.
      endif
*
      if( lgTalk ) then
        write(qq,'(3x,a74)') chTitle(2:75)
        call reageo( qq )
        call warnot( qq )
        call caunot( qq )
        call bangot( qq )
        call noteot( qq )
      endif
*
*     option to print warnings on special io
      if( lgPrnErr ) call warnot( ioPrnErr )
*
      end
