**************************************************************************
      real function crsdst( freq , nd , chAbedo )
      implicit none
*interpolate on grains cross section, called once per calculation
      real freq
      character*4 chAbedo 
      integer nd
*
      include "limcrs.par"
      include "ndust.par"
      include "dust.com"
      include "dstfac.com"
*
*     local variables
      real xlog(limcrs) , crs1(limcrs) 
      character*4 chScat
      logical lgFirst , lgNew
      save lgFirst , lgNew , ncrs , ndold , chScat , xlog , crs1
      integer ndold , ncrs , i
      real x , y
*
      data lgFirst/.true./ , ndold/-1/ , chScat/'NONE'/
*
      if( lgFirst ) then
        lgNew = .true.
        ndold = nd
        chScat = chAbedo
        lgFirst = .false.
      else
        if(nd.ne.ndold .or. chScat.ne.chAbedo ) then
          lgNew = .true.
          ndold = nd
          chScat = chAbedo
        else
          lgNew = .false.
        endif
      endif
*
      if( lgNew ) then
        ncrs = ndpts(nd)
        if( chAbedo.eq.'ABSO' ) then
*         do absorption cross sections
          do i=1,ncrs
            xlog(i) = eev(i,nd)
*           dust scross section with log of depletion scale factor
*           >>chng 97 july 17, now remove depletion, so physical quantity
*           crs1(i) = sab(i,nd) * dstfactor(nd)
            crs1(i) = sab(i,nd)
          end do
        else if( chAbedo.eq.'SCAT' ) then
*         do scattering cross sections
          do i=1,ncrs
            xlog(i) = eev(i,nd)
*           dust scross section with scale factor
*           >>chng 97 july 17, now remove depletion, so physical quantity
*           crs1(i) = sse(i,nd) * dstfactor(nd)
            crs1(i) = sse(i,nd)
          end do
        else
          stop
        endif
      endif
*
      x = log10( freq )
      if( x.lt.eev(1,nd) .or. x.gt.eev(ncrs,nd) ) then
         crsdst = 0.
      else
        call lint( xlog , crs1 , ncrs , x , y )
        crsdst = 10.**y
      endif
*
      end
