******************************************************************************
      subroutine dgaunt( chCard )
      implicit none
*drive gaunt factor routines by letting user query values
      character chCard*80
*
      include "phycon.com"
      include "logte.com"
      include "IOqq.com"
*
      logical lgEOL
      integer i , if1 , ierror
      real ener(1) , gfac(1) , fread
*
*     this routine is entered with the command DRIVE GAUNT, and
*     drives the gaunt factor routine to check range
*
      write(qq,'('' Enter the temperature (log if <=10) and energy '',
     1''(Ryd). Null line to stop.'')')
*     >>chng 96 july 7, got rid of statement labels replacing with do while
*
      ierror = 0
      do while( ierror.eq.0 )
        read(5,'(A80)',iostat=ierror) chCard
        i = 1
        te = fread( chCard , i , 76 , lgEOL )
*       the line may be trash but ierror will pick it up 
        if( lgEOL .or. ierror.ne.0 ) then
          write(qq,'('' Gaunt driver exits, enter next line.'')')
          return
        endif
*       numbers less than or equal to 10 are the log of the temperature
        if( te.le.10. ) then
          alogte  = te
        else
          alogte = log10( te )
        endif
*
        ener(1) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL.or.ener(1).eq.0. ) then
          write(qq,'('' Sorry, but there should be a second nonzero '',
     1    ''number, the energy.'')')
        endif
*
        if( ener(1).gt.0. ) then
          ener(1) = log10( ener(1) )
        endif
*
        call gffsub(0.,ener,gfac,1,1,1,if1)
        write(qq,'('' Gaunt factor is'',1P,E11.3)') gfac 
*
*       if1=1 if GAMS is out of range; 2 if U is out of range.
        if( if1.ne.0 ) write(qq,'('' Failure mode is'',I2)')if1
*
      end do
*
      end
