******************************************************************************
      real function escpcn( tau , hnukt )
      implicit none
*continuum escape probability
      real tau  , hnukt
      include "chnukt.com"
      external conrec , conesc
*
*     local variables
      real dinc , sumrec , sumesc
*
*     computes continuum escape probabilities
      if( tau.lt.0.01 ) then
        escpcn = 1.
        return
      else if( hnukt.gt.1. .and. tau.gt.100. ) then
        escpcn = 1e-20
        return
      endif
*
      ContTkt = hnukt
      ctau = tau
*
      dinc = 10./hnukt
      call qg32( 1. , 1.+dinc , conrec , sumrec )
      call qg32( 1. , 1.+dinc , conesc , sumesc )
*
      if( sumrec.gt.0. ) then
        escpcn = sumesc/sumrec
      else
        escpcn = 0.
      endif
*
      end
