******************************************************************************
      real function escsub( tau , tout , damp )
      implicit none
*escape probability radiative transfer for subordinate lines
      real tau , tout , damp
      include "touton.com"
      include "twoway.com"
      include "escdst.com"
*
*     local variables
      real scale , t , esccom
      parameter (scale=2.)
*
      if( lgTauOutOn ) then
*       outward optical depths are defined, but don't let them go negat
        t = (tout - tau)
*        help convergence by not letting tau go to zero at back edge of
*        when there was a bad guess for the total optical depth
*note that this test is seldom hit since makestatrt does check for overrun
        if( t.lt.0. ) t = tau / scale
        wayin = esccom(tau, damp )
        wayout = esccom(t, damp )
        fracin = wayin / (wayin + wayout )
        escsub = 0.5 * ( wayin + wayout )
      else
*       first iteration, outward optical depths not defined
*       dont estimate fraction in
        fracin = 0.
        wayout = 1.
        escsub = esccom( tau , damp )
        wayin = escsub
      endif
*
      end
