******************************************************************************
      subroutine GetInit(chCard)
      implicit none
*bring an initialization file into input stream before parse 
      character chCard*80
      include "IOqq.com"
      include "nkrd.par"
      include "input.com"
      include "ninput.com"
      include "OrgCard.com"
      include "path.com"
      include "pthset.com"
*
*     local variables
      logical lgMatch , lgHit1 , lgHit2
      character chLine*80 , chK1*1 , chName*80 , chC1*1 , chC2*1
      integer IOini , j , i , ierr, ip ,nName
      data IOini/94/
      data chC1,chC2/'"',''''/
*
      if( lgMatch('FILE',chCard) ) then
*       option to give ini file a different name
        lgHit1 = .false.
        i = 5
*     >>chng 97 june 18, get rid of go to
        do while( i.lt.80 .and. .not.lgHit1 )
*       do i=5,80
          if((chCard(i:i).eq.chC1).or.(chCard(i:i).eq.chC2)) then
            lgHit1 = .true.
            lgHit2 = .false.
            j = i + 1
            do while( j.lt.80 .and. .not.lgHit2 )
*           doj=i+1,80
              if((chCard(j:j).eq.chC1).or.(chCard(j:j).eq.chC2)) then
                lgHit2 = .true.
                nName = j - i - 1
*               use orginal form of line image before forced to caps
                chName(1:nName) = chOrgCard(i+1:j-1)
*               go to111
              endif
              j = j + 1
            end do
            if(.not.lgHit2 ) then
              write(qq,'('' I could not find the end of the name.'')')
              write(qq,'('' the name of the init file must appear in '',
     1        ''quotes.'')')
              stop
            endif
          endif
          i = i + 1
        end do
        if( .not.lgHit1 ) then
          write(qq,'('' I could not find the start of the name.'')')
          write(qq,'('' The name of the init file must appear in '',
     1    ''quotes.'')')
          stop
        endif
*111    continue
      else
        chName(1:10) = 'cloudy.ini'
        nName = 10
      endif
*     option to get cloudy.ini from a path
      if( lgPathSet.and. lgMatch('PATH',chCard) ) then
        i = 1
*     >>chng 97 june 18 get rid of go to 
        do while( i.lt.80 .and. chPath(i:i).ne.' ' )
*       do i=1,80
          chLine(i:i) = chPath(i:i)
          i = i + 1
        end do
*2      continue
*       i now points to first free character
        chLine(i:i+nName-1) = chName
*       end string with zero character
        chLine(i+nName:i+nName) = char(0)
      else
        chLine(1:nName) = chName
*       end string with zero character
        chLine(nName+1:nName+1) = char(0)
      endif
*
*     get cloudy.ini initialization file
      open(IOini,file=chLine ,status='old',iostat=ierr)
      if( ierr.ne.0 .and. .not.lgPathSet ) then
*       this branch, file not found, path was not set
        write(qq,'('' GetInit could not find initialization file'',
     1  '' cloudy.ini'')')
        write(qq,'('' The path I tried follows:'')')
        write(qq,'(a80)') chLine
        stop
      else if( ierr.ne.0 ) then
*       this option - no ini file here, but path was set
*       we will check for an ini file on the path
        i = 1
*     >>chng 97 june 18, get rid of go to 
        do while( i.lt.80 .and. chPath(i:i).ne.' ' )
          chLine(i:i) = chPath(i:i)
          i = i + 1
        end do
*20     continue
*       j now points to first free character
        chLine(i:i+nName-1) = chName
*       end string with zero character
        chLine(i+nName:i+nName) = char(0)
        open(IOini,file=chLine ,status='old',iostat=ierr)
        if(ierr.ne.0 ) then
*         still could not find it
          write(qq,'('' GetInit could not find initialization file'',
     1    '' cloudy.ini'')')
          write(qq,'('' The path I tried follows:'')')
          write(qq,'(a80)') chLine
          write(qq,'('' The path as set was:'')')
          write(qq,'(a80)') chPath
          write(qq,'('' The name was:'')')
          write(qq,'(a80)') chName
          stop
        endif
      endif
*
      nSaveIni = 1
*     >>chng 97 june 25, get rid of statement labels in following loop
*999  continue
      ip = nkrd+1-nSaveIni
      read(IOini,'(a80)',iostat=ierr) chCardSav(ip)
      chK1 = chCardSav(ip)(1:1)
      do while( ierr.eq.0 .and. chCardSav(ip)(1:4).ne.'    ' )
        nSaveIni = nSaveIni + 1
        ip = nkrd+1-nSaveIni
        if( ip.le.nSave ) then
          write(qq,'('' Too many ini lines.  Total of all input and '',
     1    ''ini lines cannot exceed nkrd, presently'',i4)') nkrd
          stop
        endif
        read(IOini,'(a80)',iostat=ierr) chCardSav(ip)
        chK1 = chCardSav(ip)(1:1)
        do while( ierr.eq.0 .and.
     1    (chK1.eq.'#' .or. chK1.eq.'*' .or. chK1.eq.'%' )  )
          read(IOini,'(a80)',iostat=ierr ) chCardSav(ip)
*         totally ignore any card starting with a #, *, or %
          chK1 = chCardSav(ip)(1:1)
        end do
      end do
*     go to999
*
*908  continue
      close(IOini)
*     last one with real data is nkrd+1-nSaveIni
      nSaveIni = nSaveIni - 1
*
*     following code prints out all read in line images
*     write(6,*)' nkrd=',nkrd,' nSaveIni=',nSaveIni
*     write(6,'(a80)') (chCardSav(ip),ip=nkrd,nkrd+1-nSaveIni,-1)
*
      end
