******************************************************************
      subroutine GetMaxhLine
      implicit none
*find the strongest heating line
      include "ipLnArry.par"
      include "nta.par"
      include "nwindline.par"
      include "heatlmax.com"
      include "WindData.com"
      include "TLineARR.com"
*
*     local variables
      integer i
      real strong
*
*     routine called to find which is the strongest heating line
      strong = 0.
*     possible for levlmax to remain 0 if induced processes turned off
      levlmax = 0
      do i=1,nTauLines
        if( TauLines(ipLnHeat,i).gt.strong ) then
          strong = TauLines(ipLnHeat,i)
          levlmax = 1
          ipHeatlmax = i
        endif
      end do
      do i=1,NWINDLINE*nWindOn
        if( WindLine(ipLnHeat,i).gt.strong ) then
          strong = WindLine(ipLnHeat,i)
          levlmax = 2
          ipHeatlmax = i
        endif
      end do
      end
