*******************************************************************************
      subroutine GetNorm( chCard )
      implicit none
*parse parameters on the normalize command
      character chCard*80
      include "norm.com"
      include "IOqq.com"
*
*     local variables
      integer i , ipQ
      real fread
      logical lgEOL , lgHit
      character chQ1*1 , chQ2*1
      data chQ1/'"'/ , chQ2/''''/
*
*     normalise lines to this rather than h-b, sec number is scale factor
      i = 5
      NormWL = -fread( chCard , i , 76 , lgEOL )
*     neg sign is flag that NormWL is wavelength not pointer to line array element
*     startr will convert it to a pointer in the line stack
      if( lgEOL ) call NoNumb(chCard )
      sclnrm = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) sclnrm = 1.
*     confirm that scale factor is positive
      if( sclnrm.le.0. ) then
        write(qq,'('' The scale factor for relative intensities must '',
     1  ''be greater than zero.'')')
        write(qq,'(''Sorry.'')')
        stop
      endif
*
*     check whether there is a label on the line
      i = 4
      lgHit = .false.
      ipQ = 0
      do while( .not.lgHit .and.i.lt.73 )
        if( (chCard(i:i).eq.chQ1) .or. (chCard(i:i).eq.chQ2) ) then
          ipQ = i
          lgHit = .true.
        endif
        i = i + 1
      end do
*
      if( lgHit ) then
*       got quote, check both quotes are there
        if( (chCard(ipQ+5:ipQ+5).ne.chQ1) .and.
     1    (chCard(ipQ+5:ipQ+5).ne.chQ2) ) then
          write(qq,'('' for normalize command with labels, two '',
     1    ''quotes are needed'')')
          stop
        endif
*       must use orginal card image
        chNormLab = chCard(ipQ+1:ipQ+4)
      endif
*
      end
