******************************************************************************
      real function he1jbr( ihi , low )
      implicit none
*returns continuum occupation number for helium singlet lines
      integer ihi , low
*
      include "ncell.par"
      include "nhe1lvl.par"
      include "occnum.com"
      include "fluors.com"
      include "iphe1l.com"
      include "IOqq.com"
*
*begin sanity check
      if( iphe1l(ihi,low).le.0 .or. iphe1l(ihi,low).gt.ncell ) then
        write(qq,'('' he1jbr insane hei line pointer:'',i5,
     1  '' ihi,low='',2i5)') iphe1l(ihi,low),ihi,low
        call ShowMe
        stop
      endif
*end sanity check
*
      if( lgFluor ) then
        he1jbr = occnum( iphe1l(ihi,low) )
      else
*       option to turn off continuum fluorsecent excitation with
*       "no induced" command
        he1jbr = 0.
      endif
*
      end
