******************************************************************************
      real function hjbar(ihi,low)
      implicit none
*return continuum occupation number for any hydrogen line
      integer ihi,low
      include "ncell.par"
      include "nhlvl.par"
      include "occnum.com"
      include "fluors.com"
      include "iphl.com"
*
*     HJBAR returns photon occupation number for continuum at energy
*     of the IHI to LOW transition of hydrogen
*
      if( lgFluor ) then
        hjbar = occnum( iphl(ihi,low) )
      else
*       option to turn off continuum fluorsecent excitation with
*       "no induced" command
        hjbar = 0.
      endif
*
      end
