******************************************************************************
      subroutine pcnrng( chCard )
      implicit none
*set range for map to parse range option on map command
      character chCard*80
      include "ndplot.par"
      include "bounds.com"
      include "ploton.com"
      include "IOqq.com"
*
      logical lgLogOn , lgMatch , lgEOL
      real fread , a
      integer i
*
      i = 4
      pltxmn(nplot) = fread( chCard , i , 76 , lgEOL )
*
      if(.not.lgMatch( 'RANG' , chCard ) ) then
*        no numbers on line, just set default limits to energy array
         pltxmn(nplot) = log10( emm )
         pltxmx(nplot) = log10( egamry )
         lgLogOn = .true.
      else if( lgEOL ) then
*        no numbers on line, just set default limits to energy array
         pltxmn(nplot) = log10( emm )
         pltxmx(nplot) = log10( egamry )
         lgLogOn = .true.
      else
*        lower limit entered, now interprete it
         if( pltxmn(nplot).lt.0. ) then
            lgLogOn = .true.
         else if( pltxmn(nplot).eq.0.0 ) then
*           option for first number to be zero, lower edge of array
            lgLogOn = .false.
            pltxmn(nplot) = emm
         else
*           a positive number was entered
            lgLogOn = .false.
         endif
*
*        now look at upper limit
         pltxmx(nplot) = fread( chCard , i , 76 , lgEOL )
         if( lgEOL.or. pltxmx(nplot).eq.0.0 ) then
*           option for second number to be omitted or zero
            if( lgLogOn ) then
               pltxmx(nplot) = log10( egamry )
            else
               pltxmx(nplot) = egamry
            endif
         endif
      endif
*
*     now force to be log
      if( .not.lgLogOn ) then
         pltxmx(nplot) = log10( pltxmx(nplot) )
         pltxmn(nplot) = log10( pltxmn(nplot) )
      endif
*
*     check that min is less than max
      if( pltxmn(nplot).eq.pltxmx(nplot) ) then
         write(qq,'('' Upper and lower plot boundaries are equal.'')')
         stop
      else if( pltxmn(nplot).gt.pltxmx(nplot) ) then
         a = pltxmx(nplot)
         pltxmx(nplot) = pltxmn(nplot)
         pltxmn(nplot) = a
      endif
*
      end
