******************************************************************************
*     subroutine m01alf(ia,iw,l,indw,n,nw,ifail)
*     implicit none
*     integer ia(1) , iw(1) , l(1) , indw(1)
*     integer n,nw,ifail
*     include "IOqq.com"
*
*     WRITE(QQ,'('' The PRINT SORT option has not been fully '',
*    1 ''implemented.'')')
*     WRITE(QQ,'('' Address all complaints to Peter G. Martin.'')')
*
*     STOP
*     END

******************************************************************************
      subroutine pgaunt( io )
      implicit none
*called by punch gaunts command to output gaunt factors
      integer io
      include "ncell.par"
      include "phycon.com"
      include "rfield.com"
      include "logte.com"
      include "gaunts.com"
*
*     local variables
      integer nte , nenr , i , ite, j,if1
      parameter (nte=21 , nenr=31)
      real ener(nenr) , g(nte,nenr) , gfac , ste(nte) ,z
      integer ier(nte,nenr)
*
*     this routine is called from the PUNCH GAUNTS command
*     it drives the gaunt factor routine to punch gaunts over full range
*
      do i=1,nte
        ste(i) = 0.5*(i-1)
      end do
      do i=1,nenr
        ener(i) = 0.5*(i-1)-5.
      end do
*
*     ener is log of energy
      do ite=1,nte
        alogte = ste(ite)
*       nuclear charge
        z = log10(1.)
        do j=1,nenr
          call gffsub(z,ener(j),gfac,1,1,1,if1)
          g(ite,j) = gfac
          ier(ite,j) = if1
        end do
      end do
*
*     now punch out the results
      write(io,'(6x,21f6.1)') (ste(i),i=1,nte)
      do j=1,nenr
        write(io,'(22f6.2)') ener(j),(log10(g(ite,j)),ite=1,nte)
      end do
*
      write(io,'(6x,21f6.1)') (ste(i),i=1,nte)
      do j=1,nenr
        write(io,'(f6.3,21i6)') ener(j),(ier(ite,j),ite=1,nte)
      end do
*
*     now do the same thing as triplets
      write(io,'(6x,21f6.1)') (ste(i),i=1,nte)
      do i=1,nte
        do j=1,nenr
          write(io,'(22f6.2)') ste(i),ener(j),log10(g(i,j))
        end do
      end do
*
      end
