******************************************************************************
      subroutine PrintElem( chJob , chLabl , abund )
      implicit none
*print chemical composition at start of calculation
      character chJob*4 , chLabl*2
      real abund
*
      include "IOqq.com"
      integer limit
      parameter (limit=9)
      character chAllLabels(limit)*13
      integer ipnt , i , noffset
      save ipnt, chAllLabels
*
      if( chJob.eq.'init' ) then
        ipnt = 0
        write(qq,'(57x,''Chemical Composition'')')
      else if( chJob.eq.'fill' ) then
        ipnt = ipnt + 1
        write(chAllLabels(ipnt),'(2x,a2,'':'',1p,e8.2)') chLabl,abund
        if( ipnt.eq.limit ) then
          write(qq,'(6x,9a13)') (chAllLabels(i),i=1,limit)
          ipnt = 0
        endif
      else if( chJob.eq.'flus' ) then
*       flush the stack
        i = limit - ipnt
        noffset = i / 2
        do i=ipnt,1,-1
          chAllLabels(i+noffset) = chAllLabels(i)
        end do
        do i=1,noffset
          write(chAllLabels(i),'(13x)')
        end do
        write(qq,'(6x,9a13)') (chAllLabels(i),i=1,ipnt+noffset)
      else
        write(qq,'('' PrintElem does not understand job='',a4)')chJob
        stop
      endif
*
      end
