******************************************************************************
      subroutine prme( chDoIt , array )
      implicit none
*print heavy element line optical depths at end of calculation
      include "nta.par"
      include "limelm.par"
      include "ipLnArry.par"
      include "ElmntSym.com"
      include "PrtTau.com"
      include "IOqq.com"
*
      real array(nta)
      character chLabel*2 , chDoIt*2
*
*     local variables
      integer i , n
      integer nlim
      parameter (nlim=6)
      character chLsav(nlim)*10 , chLineLbl*10
      real tsav(nlim) 
      save chLsav , tsav , n
*
*     this routine is called by prtmet, and is used to print out
*     line optical depths after model complete - it IS NOT a
*     timing pace setter
*
*     label for line
      chLabel = chElementSym(int(array(ipLnNelem)))
*
      if( chDoIt.eq.'In' ) then
        n = 0
*
      else if( chDoIt.EQ.'  ' ) THEN
*       NB number in following statement must agree with nlim
        write(qq,'(2X,6(1X,A10,1P,E9.2))')
     1  (chLsav(i),tsav(i),i=1,n)
*
      else if( array(ipLnTauIn).gt.PrtTauFnt .or.
     1  array(ipLnTauIn).lt.0.) then
*       array(ipLnTauIn) is the optical depth
*       PrtTauFnt is threshold for printing it
        n = n + 1
        if( n.gt.nlim ) then
*       NB number in following statement must agree with nlim
          write(qq,'(2X,6(1X,A10,1P,E9.2))')
     1    (chLsav(i),tsav(i),i=1,nlim)
          n = 1
        endif
*
        chLsav(n) = chLineLbl( array )
        tsav(n) = array(ipLnTauIn)
      endif
*
      end
