******************************************************************************
      subroutine PutHetCol( te , htot , ctot )
      implicit none
*save heating, cooling, and temperature in stack for numerical derivatives
      real te , htot , ctot
      include "nGrid.par"
      include "itrdim.par"
      include "HeatCool.com"
      include "ZoneCnt.com"
      include "IOqq.com"
*
      if( nzone.eq.0 ) then
*       code is searching for first temp now - do not remember these numbers
        ipGrid = 0
      else
        ipGrid = ipGrid + 1
        if( ipGrid.gt.nGrid ) ipGrid = 1
*begin sanity checks
        if(ipGrid.le.0 .or. ipGrid.gt.nGrid ) then
          write(qq,'('' PutHetCol has insane ipGrid'',i5)')ipGrid
          call ShowMe
        endif
        if(nzone.le.0 ) then
          write(qq,'('' PutHetCol has insane nzone'',i5)')nzone
          call ShowMe
        endif
*end sanity checks
        TeGrid(ipGrid) = te
        HtGrid(ipGrid) = htot
        ClGrid(ipGrid) = ctot
        nZonGrid(ipGrid) = nzone
      endif
*
      end
