**************************************************************
      subroutine rdfile(kard,i,igr)
      implicit none
*read grains parameters from a file.  It is called when the grain number  >10
* The sublimation temperature is a new addition for c90.
* This subroutine added by (K Volk) 27 August 1993
      character*80 kard
      include "ndust.par"
      include "nqgrid.par"
      include "limcrs.par"
      include "dstfac.com"
      include "sublimat.com"
      include "dstlab.com"
      include "dwork.com"
      include "dust.com"
      include "qheat2.com"
      include "dustab.com"
      include "lastdt.com"
*
*     local variables
      integer i,j,i1,l,j1,j2,ierr,igr
      character*70 fname
      real s1
*
* first, get the file name from the kard variable
*
      do j=1,70
        fname(j:j)=' '
      end do
*
      i1=i
*
* try to read the file name, remembering that the qheat keyword might be first
*
      do l=1,2
       j1=0
       j2=0
*
       do j=i1,80
         if (kard(j:j).ne.' '.and.j1.eq.0) j1=j
         if (kard(j:j).eq.' '.and.j1.ne.0) j2=j
         if (j2.gt.0) goto 552
       end do
*
        if (j.eq.81.and.j1.gt.0) j2=80
        if (j.eq.81.and.j1.eq.0) goto 557
 552    fname(1:j2-j1+1)=kard(j1:j2)
        if ((fname.eq.'qheat'.or.fname.eq.'QHEAT').and.j2.lt.80) then
          i1=j2+1
        else
          goto 557
        end if
      end do

 557  if (j1.eq.0.or.j2.eq.0) fname='dust.val '
      ierr=1
      open(unit=89,file=fname,status='old',err=587)
      s1=sublimat(igr)
*
*     >>chng 97 jan 5, get rid of statement number
      read(89,'(1x,a10,2x,f7.3,1x,i1,1x,e12.4,1x,e12.4,1x,f7.1)'
     1 ,err=585,end=585) chDstLab(igr),DustWorkFcn(igr),
     1 itype(igr-10), anumkv(igr-10),qhnrat(igr),sublimat(igr)
*560  format(1x,a10,2x,f7.3,1x,i1,1x,e12.4,1x,e12.4,1x,f7.1)
      if (sublimat(igr).le.50.) sublimat(igr)=s1
* The "old" dust input file does not have the sublimation temperature 
* so it is reset to the initial value if it is zero, or if the value is 
* absurdly small.
*
      read(89,'(e9.3,1x,e9.3,1x,e9.3,1x,e9.3,1x,i3,1x,e9.3,1x,e9.3)'
     1 ,err=585,end=585) (dustp(i,igr),i=1,4),ndpts(igr),
     2                             darea(igr),dsize(igr)
*     >>chng 97 jan 5, get rid of statement number
*565  format(e9.3,1x,e9.3,1x,e9.3,1x,e9.3,1x,i3,1x,e9.3,1x,e9.3)
*
      if (ndpts(igr).gt.limcrs) ndpts(igr)=limcrs
*
      read(89,'(4(f5.1,1x,e12.4))', err=585,end=585) (dstelz(j,igr),
     1                              dstela(j,igr),j=1,4)
*     >>chng 97 jan 5, get rid of statement number
*567  format(4(f5.1,1x,e12.4))
*
      do i=1,ndpts(igr)
      read(89,'(3f11.5)',err=585,end=585) eev(i,igr),sab(i,igr),
     c                             sse(i,igr)
*570  format(3f11.5)
      end do
*
      ierr=0
 585  close(unit=89)
 587  if (ierr.eq.1) then
        write(06,'('' Error - the file specified for dust '',i2,
     c  '' could not be read properly.'')') igr
        lgDustOn1(igr)=.false.
        stop
      end if
*
      end
