******************************************************************************
      subroutine setflx( chCard , nqh , ar1 , chType , lgNU2 )
      implicit none
*parse intensity command parameters
      integer nqh
      logical lgNU2
      character chType*4 , chCard*80
      real ar1
*
      include "fr1ryd.par"
      include "limspc.par"
      include "itrdim.par"
      include "HIonPot.par"
      include "rdfalt.com"
      include "called.com"
      include "range.com"
      include "spnorm.com"
      include "spec.com"
      include "radius.com"
      include "IOqq.com"
*
*     local variables
      logical lgEOL
      integer i
      real fread , fr
*
*     flux density of this continuum source, at optional frequency
      i = 5
      nqh = nqh + 1
      if( nqh.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC''
     1  )')
        stop
      endif
*
      chRSpec(nqh) = chType
      totpow(nqh) = fread( chCard , i , 76 , lgEOL )
*
*     large luminosity but per sq cm
      if( totpow(nqh).gt.37. .and.chRSpec(nqh).eq.'SQCM' )
     1  write(qq,'('' This intensity is VERY'',
     1 '' large.  Problems?  Was luminosity intended??'')')
*
      if( lgEOL ) then
        if(.not.lgTalk) write(qq,'(1X,A80)') chCard
        write(qq,'('' There should have been a number on this '',
     1  ''line.   Sorry.'')')
        stop
      endif
*
      chSpNorm(nqh) = 'FLUX'
*     this is optional frequency in Rydbergs
      range(nqh,1) = fread( chCard , i , 76 , lgEOL )
*     >>chng 96 dec 18, was 1 changed to H mass nuc ryd
*     if( lgEOL ) range(nqh,1) = 1.
      if( lgEOL ) range(nqh,1) = HIonPot
      if( range(nqh,1).le.0. ) range(nqh,1) = 10.** range(nqh,1)
*
      if( lgNU2 ) then
*       range is now freq in ryd, totpow is log of product nu*f_nu
        fr = log10( range(nqh,1)* fr1ryd )
        totpow(nqh) = totpow(nqh) - fr
      endif
*
*     set R to large value in case R not specified (per sq cm)
*     and this is per unit area
      if( chType.eq.'SQCM' .and. radius.eq.0. ) then
*       RDFALT in BLOCK DATA SCALAR, is 25
        ar1 = rdfalt
        radius = 10.**ar1
      endif
*
      end
