******************************************************************************
      subroutine tauchn( tauary )
      implicit none
*increment optical depths for all heavy element lines, zone by zone
      include "nta.par"
      include "ipLnArry.par"
      real tauary(nta)
*
      include "limelm.par"
      include "DoppVel.com"
      include "filfac.com"
      include "dRdVeff.com"
      include "wind.com"
      include "windeff.com"
      include "dtMase.com"
*
*     local variables
      real vel , dtau
*
*     routine increments optical depths for static or exanding atmosphere
*
      vel = doppler(int(tauary(ipLnNelem)+.1))
      if( windv.eq.0. ) then
*       static solution
        tauary(ipLnDTau) = tauary(ipLnPopOpc)*tauary(ipLnOpac) / vel
        dtau = tauary(ipLnDTau) * dReff
*     >>chng 97 mar 18, put in for heavy elements, to stop FeII maser from
*killing Katya's atom
        tauary(ipLnTauIn) = tauary(ipLnTauIn) + dtau
        dTauMase = min(dTauMase,dtau)
*       following stops disaster, will allow escape prob to get big and
*       damp out the maser
        dtau = max( -1., dtau )
        tauary(ipLnTauCon) = tauary(ipLnTauCon) + tauary(ipLnDTau)*dReff
      else
*       wind
        tauary(ipLnTauIn) = wndeff * tauary(ipLnPopOpc)*tauary(ipLnOpac)
        tauary(ipLnTauCon) = tauary(ipLnTauIn)
*       save for continuum pumping array
*       tauary(ipLnDTau) = tauary(ipLnTauIn) / dReff
*       >>chng 96 jan 15 above had been place,
*       current nova.in crashed due to small dr
*       why was it as above?
        tauary(ipLnDTau) = tauary(ipLnPopOpc)*tauary(ipLnOpac) *
     1  FillFac / max(doppler(1),vel)
        tauary(ipLnTauTot) = tauary(ipLnTauIn)
      endif
*
      end
