****************************************************************
      subroutine ZeroFe2
      implicit none
*zero out storage for Katya's FeII atom
      include "nFe2LevN.par"
      include "ipLnArry.par"
      include "nta.par"
      include "Fe2LevN.com"
      include "taumin.com"
*     local variables
      integer lo , iup
*
*     this routine is called in routine zero and it
*     zero's out various elements of the fe2 arrays
*     it is called on every iteration
*
      do lo=1,nFe2LevN-1
        do iup=lo+1,nFe2LevN
*         inward optical depth
          Fe2LevN(ipLnTauIn,iup,lo) = taumin
          Fe2LevN(ipLnTauCon,iup,lo) = taumin
          Fe2LevN(ipLnColovTOT,iup,lo) = taumin
*         outward optical depth
          Fe2LevN(ipLnTauTot,iup,lo) = 1e20
*         escape probability
          Fe2LevN(ipLnEscP,iup,lo) = 1.
*         inward part of line
          Fe2LevN(ipLnInwd,iup,lo) = 1.
*         destruction probability
          Fe2LevN(ipLnDesP,iup,lo) = 0.
*         line pumping rate
          Fe2LevN(ipLnPump,iup,lo) = 0.
*         population of lower level with correction for stim emission
          Fe2LevN(ipLnPopOpc,iup,lo) = 0.
*         population of lower level
          Fe2LevN(ipLnPopl,iup,lo) = 0.
*         following two heat exchange excitation, deexcitation
          Fe2LevN(ipLnCool,iup,lo) = 0.
          Fe2LevN(ipLnHeat,iup,lo) = 0.
*         intensity of line
          Fe2LevN(ipLnInten,iup,lo) = 0.
*         number of photons emitted in line
          Fe2LevN(ipLnNPhots,iup,lo) = 0.
*         opacity in line
          Fe2LevN(ipLnDTau,iup,lo) = 0.
        end do
      end do
*
      end
