******************************************************************************
      subroutine absmag( chCard , nqh )
      implicit none
*parse the absolute magnitude command
      character chCard*80
      integer nqh
*
      include "bounds.com"
      include "called.com"
      include "limspc.par"
      include "range.com"
      include "spnorm.com"
      include "spec.com"
      include "sptype.com"
      include "IOqq.com"
      logical lgEOL , lgMatch
*
*     local variables
      integer i
      real fread
*
*     enter luminosity in absolute magnitudes
      i = 5
      nqh = nqh + 1
      if( nqh.gt.limspc ) then
         if(lgTalk) write(qq,'('' Too many continua entered; increase '',
     1   ''LIMSPC'')')
         stop
      endif
      chRSpec(nqh) = '4 PI'
      totpow(nqh) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
         if(lgTalk) write(qq,'('' There should have been a number on '',
     1   ''this line.   Sorry.'')')
         stop
      endif
      if( lgMatch('BOLO' , chCard ) ) then
        chSpNorm(nqh) = 'LUMI'
        range(nqh,1) = emm
        range(nqh,2) = egamry
*       page 197 allen 76
        totpow(nqh) = (4.75 - totpow(nqh)) / 2.5  + 33.5827
      else if( lgMatch('VISU', chCard ) ) THEN
        chSpNorm(nqh) = 'FLUX'
*       this is 5550A, the center of the V filter
        range(nqh,1) = 0.164
*       totpow(nqh) = (4.79 - totpow(nqh)) / 2.5  + 18.758
*       page 197, allen 76, 3rd line from bottom
        totpow(nqh) =  -totpow(nqh)/2.5  + 20.65296
      else
        if(lgTalk) write(qq,'('' Keyword BOLOmetric or VISUal must '',
     1  ''appear.'')')
        stop
      endif
*
      end
