**************************************************************
      real function AnuUnit( ip )
      implicit none
*produce continuum energy in arbitrary units
      integer ip
      include "limpun.par"
      include "rydlam.par"
      include "evryd.par"
      include "ncell.par"
      include "cpunch.com"
      include "anusave.com"
      include "IOqq.com"
*
      if( chConPunEnr(ipConPunEnr) .eq. 'ryd ' ) then
*       energy in Ryd
        AnuUnit = AnuOrg(ip)
      else if( chConPunEnr(ipConPunEnr) .eq. 'micr' ) then
*       wavelength in microns
        AnuUnit = rydlam / AnuOrg(ip) * 1e-4
      else if( chConPunEnr(ipConPunEnr) .eq. ' kev' ) then
*       energy in keV
        AnuUnit = AnuOrg(ip) * evryd * 1.e-3
      else if( chConPunEnr(ipConPunEnr) .eq. ' ev ' ) then
*       energy in eV
        AnuUnit = AnuOrg(ip) * evryd
      else if( chConPunEnr(ipConPunEnr) .eq. 'angs' ) then
*       wavelength in Angstroms
        AnuUnit = rydlam / AnuOrg(ip)
      else
        write(qq,'('' insane units in AnuUnit ='',a4)')
     1  chConPunEnr(ipConPunEnr) 
        stop
      endif
*
      end
