******************************************************************************
      subroutine aver( chWhat , quan, weight , chLabl )
      implicit none
*compute average of various quantities over the computed geometry
      character chWhat*4 , chLabl*10 
      real quan , weight
*
      include "dRdVeff.com"
      include "sphere.com"
      include "IOqq.com"
*
*     local variables
      integer i , j , n , ioff
*     NAVER is the limit to the number than can be averaged
      integer naver
      parameter (naver=20)
      character chLabavr(naver)*10 , chTitAvr*132
      save chLabavr , chTitAvr
      double precision aversv(naver,4) , vaver(naver) , raver(naver)
      save aversv , n
*
      if( chWhat.eq.'zero' ) then
*       chWhat='zero' - zero out the save array
        do i=1,naver
          do j=1,4
            aversv(i,j) = 0.
          end do
        end do
        n = 0
      else if( chWhat.eq.'zone' ) then
        n = 0
      else if( chWhat.eq.'doit' ) then
*       chWhat='doit' - enter values to average
        n = n + 1
        if( n.gt.naver ) then
          write(qq,'('' Too many values entered into AVER, '',
     1    ''increase NAVER'')')
          stop
        endif
*       SUBROUTINE AVER( chWhat , QUAN, weight , chLabl )
        aversv(n,1) = aversv(n,1) + weight*dble(quan)*dble(dReff)
        aversv(n,2) = aversv(n,2) +      weight*dble(dReff)
        aversv(n,3) = aversv(n,3) + weight*dble(quan)*dble(dVeff)
        aversv(n,4) = aversv(n,4) +      weight*dble(dVeff)
        chLabavr(n) = chLabl
      else if( chWhat.eq.'prin' ) then
*       set things up to get answers
        do i=1,132
          chTitAvr(i:i) = ' '
        end do
        ioff = n*10/2+1
        chTitAvr(ioff:ioff+18) = 'Averaged Quantities'
        write(qq,'(/A130)') chTitAvr
        write(qq,'(8X,12(1X,A10))') (chLabavr(i),i=1,n)
        do i=1,n
          if( aversv(i,2).gt.0. ) then
            raver(i) = aversv(i,1) / aversv(i,2)
          else
            raver(i) = 0.
          endif
          if( aversv(i,4).gt.0. ) then
            vaver(i) = aversv(i,3) / aversv(i,4)
          else
            vaver(i) = 0.
          endif
        end do
        write(qq,'('' Radius:'',1P,10E11.3)') (raver(i),i=1,n)
*       only print vol aver is lgSphere is set
        if(lgSphere)write(qq,'('' Volume:'',1P,10E11.3)')
     1  (vaver(i),i=1,n)
      else
        write(qq,'('' AVER does not understand chWhat='',A4)') chWhat
        call ShowMe
        stop
      endif
*
      end
