*********************************************************************
      subroutine cdColm( chLabell , ion , theocl , lgOK )
      implicit none
*get the column density for a constituent 
      logical lgOK
      integer ion
      character*4 chLabell
      real theocl
*
      include "limelm.par"
      include "ElNames.com"
      include "IonMeans.com"
      include "IOqq.com"
*
*     local variables
      integer nelem
      character*4 chLabel
      character*80 chCard
*
*     first ensure that chLabel is all caps
      chCard(1:4) = chLabell
      call caps( chCard )
      chLabel = chCard(1:4)
*
*     find which element this is
      nelem = 1
      do while (nelem.le.limelm .and. chLabel.ne.chElNames(nelem) )
        nelem = nelem + 1
      end do
      if( nelem.gt.limelm ) then
        write(qq,'('' cdColm called with unknown element chLabel, ='',
     1  a4)')chLabel
        lgOK = .false.
        return
      endif
*
*     sanity check - does this ionization stage exist?
      if( ion.gt.nelem+1 ) then
        write(qq,'('' cdColm asked to return ionization stage'',i4,
     1  '' for element '',a4,'' but this is not physical.'')') ion,
     2  chLabel
        lgOK = .false.
      endif
*
      theocl = xIonMeans(nelem,ion,1)
*
      lgOK = .true.
*
      end
