**************************************************************************
      real function dintg( tdust , nd , ip )
      implicit none
*compute total radiative cooling due to large grains
      real tdust
      integer nd , ip
*
      include "ndust.par"
      include "te1ryd.par"
      include "ncell.par"
      include "dstop.com"
      include "corind.com"
      include "rfield.com"
      include "widflx.com"
      include "dstbug.com"
      include "trace.com"
      include "NumUpper.com"
      include "IOqq.com"
*
*     local variables
      double precision plexp(ncell)
      real fac , arg , sum , planck
      integer i
      real ttused
      save ttused
      data ttused/0./
*
*     Boltzmann factors for Planck integration
      fac = te1ryd / tdust
      if( tdust.ne.ttused ) then
         dintg = 0.
         do i=1,nupper
            arg = fac * anu(i)
*           this is not the defn of ContBoltz used elsewhere in program,
*           but is used here to save core
*           >>>chng 99 mar 12, as per Peter van Hoof comment, for grain
*           temps below 10K, exp being set to zero is a problem.  Must define
*           double precision array to hold these contents.
*PVH        ContBoltz(i) = exp( min( 80. , arg ))
*PVH        if( ContBoltz(i).lt.1.01 ) then
*PVH           ContBoltz(i) = arg 
*PVH        else
*PVH           ContBoltz(i) = ContBoltz(i) - 1.
*PVH        endif
            if( arg.lt.1.e-6 ) then
               plexp(i) = DBLE(arg) 
            else
               plexp(i) = exp(DBLE(min(700.,arg))) - 1.d0
            endif
         end do
         ttused = tdust
      endif
*
      dintg = 0.
      sum = 0.
      do i=1,nupper
*PVH    planck = 2.1675e16 * anu3(i) / ContBoltz(i) * widflx(i)
        planck = SNGL(2.1675d16 / plexp(i) * anu3(i) * widflx(i))
        sum = sum + planck
        dintg = dintg + planck * dstab1(i,nd)
      end do
*
      if( lgDustBug.and.lgTrace .and. ((ip-1)/5)*5.eq.(ip-1)) then
        write(qq,'(i4,1p,3e11.4)')
     1  nd,tdust,dintg,sum/4./5.6696e-5/tdust**4
      endif
*
      end
