******************************************************************************
      subroutine dmpast
      implicit none
*dump cooling, calls coolpr with most important coolants
      include "itrdim.par"
      include "limelm.par"
      include "ZoneCnt.com"
      include "tcool.com"
      include "hem.com"
      include "heat.com"
      include "ncolnt.par"
      include "collab.com"
      include "coolnt.com"
      include "IOqq.com"
      include "heating.com"
      include "phycon.com"
*
      real eps , ratio
      integer i
      parameter (eps=0.005)
*
      write(qq,'(''     All coolants greater than'',F6.2,''% of the '',
     1''total will be printed.'')') eps*100.
*
*     flag all significant coolants
      call coolpr( 'ZERO' ,1,  0.  , eps )
      do i=1,ncltot
        ratio = cooling(i)  / ctot
        call coolpr( chClntLab(i) , collam(i), ratio  , eps )
      end do
      call coolpr( 'DONE', 1 , 0.  , eps )
*
      if( heating(1,23)/ctot.gt.0.05 ) then
        write(qq,'(''     All coolant heat greater than'',F6.2,
     1  ''% of the total will be printed.'')') eps*100.
        call coolpr( 'ZERO' ,1,  0.  , eps )
        do i=1,ncltot
          ratio = heatnt(i)  / ctot
          call coolpr( chClntLab(i) , collam(i), ratio  , eps )
        end do
      call coolpr( 'DONE', 1 , 0.  , eps )
      endif
*
      end
