******************************************************************************
      real function eshe1l( esin )
      implicit none
*do radiative transfer for helium singlets lines
      real esin
      include "nhe1lvl.par"
      include "nta.par"
      include "limelm.par"
      include "DoppVel.com"
      include "he1tau.com"
      include "he1nxt.com"
      include "iphe1l.com"
      include "redis.com"
      include "twoway.com"
      include "IOqq.com"
*
*     local variables
      real damp , escgrd , escsub
*
*     evaluate esc prob for HeI LA
      damp = 606.7 / doppler(2)
      if( chRedis.EQ.'INCO' ) THEN
*        incomplete redistribution
         eshe1l = escgrd( he1nxt(2,1) , he1lim(2,1) , damp ,
     1   iphe1l(2,1) )
         esin = wayin
      else
*        wind or complete redis
         eshe1l = escsub( he1nxt(2,1) , he1lim(2,1) , damp )
         esin = wayin
      endif
      if( eshe1l.lt.0. ) then
        write(qq,'('' ESHE1L returns a negative value, of'',1P,E10.2)')
     1  eshe1l
        write(qq,'('' ESHE1L: the redistribution type was '',A4)')
     1  chRedis
        write(qq,'('' The optical depths are '',1P,2E10.2)') 
     1     he1nxt(2,1) , he1lim(2,1)
        call ShowMe
        stop
      endif
*
      end
