******************************************************************************
      subroutine extin( ex1ryd )
      implicit none
*do extinction of incident continuum as set by extinguish command
      real ex1ryd
*
      include "ncell.par"
      include "rfield.com"
      include "extinc.com"
      real absorb , sexp , factor
      integer low , i , ipoint
*
*     modify input continuum by leaky absorber
*     power law fit to Cruddace et al. 1974 ApJ 187, 497.
*
      if( excolm.eq.0. ) then
         ex1ryd = 1.
      else
*
        absorb  = 1. - exleak
        factor = excolm * 6.22e-18
*       extinction at 1 and 4 Ryd
        ex1ryd = exleak + absorb * sexp( factor )
*
        low = ipoint( exlow )
        do i=low,nflux
          flux(i) = flux(i) * 
     1    (exleak + absorb * sexp( factor * (anu(i)**(-2.43) ) ) )
        end do
*
      endif
*
      end 
