***********************************************************
      real function GetLineRec( ip , lWl )
      implicit none
*return rec coef*hnu for C, N, or O recombination lines from Dima's list
      integer ip , lWl
      include "limelm.par"
      include "RecCNO.com"
      include "IonFracs.com"
      include "phycon.com"
      include "IOqq.com"
*
*begin sanity check
      if( int(RecCoefCNO(ip,3)+0.5).ne. lWl ) then
        write(qq,'('' GetLineRec called with incorrect wavelength.'')')
        write(qq,'('' index, call and get wl are '',3i5)') ip, lWl,
     1  int(RecCoefCNO(ip,3)+0.5)
        stop
      endif
*end sanity check
*
*     final produce is vol emissivity in line
      GetLineRec = RecCoefCNO(ip,4)*eden*
     1 xIonFracs(int(RecCoefCNO(ip,1)) ,
     1   int(RecCoefCNO(ip,1)-RecCoefCNO(ip,2)+2) ) * 1.99e-8 /
     2   RecCoefCNO(ip,3)
*
*     zero out rec coef so that not used again in master dump
*     this routine cannot be called twice on same line
      RecCoefCNO( ip,4) = 0.
*
      end
