******************************************************************************
      subroutine GetTrace( chCard )
      implicit none
*read in options off the trace command line
      character chCard*80
      include "itrdim.par"
      include "itrprt.com"
      include "ZoneCnt.com"
      include "trace.com"
      include "cooltr.com"
      include "bug2nu.com"
      include "otsbug.com"
      include "conbug.com"
      include "carbug.com"
      include "calbug.com"
      include "hbug.com"
      include "hebug.com"
      include "dstbug.com"
      include "opcbug.com"
      include "tr8446.com"
      include "trdiff.com"
      include "troptm.com"
      include "drbug.com"
      include "trgant.com"
      include "heatbg.com"
      include "trmole.com"
      include "bd3bug.com"
      include "optbug.com"
      include "febug.com"
      include "trline.com"
      include "nebug.com"
      include "neonbg.com"
      include "combug.com"
      include "pntbug.com"
      include "TrLevN.com"
      include "TrConvg.com"
      include "TrHeav.com"
*
*     local variables
      logical lgMatch , lgEOL
      integer i
      real fread
*
*     turn on trace at a certain zone; .LE.0 or none for starting trace
*     optional second number is iteration to start debugger
*     optional word "hydrogen" provides more info on hydrogen solution
      i = 5
*     this is which zone to turn on
      nznbug = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) lgTrace = .true.
*     this is which iteration to turn on
      npsbug = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) npsbug = 1
*
*     turn trace on now if no numbers on line
      if( nznbug.eq.0 .and. npsbug.eq.1 ) then
        lgTrace = .true.
        nprint = 1
        itrprt(1) = 1
      endif
*
*     were there any keywords on the line?
      if( lgMatch('BETA',chCard) ) lgTr8446 = .true.
      if( lgMatch('CARB',chCard) ) lgCarBug = .true.
      if( lgMatch('CALC',chCard) ) lgCalBug = .true.
      if( lgMatch('COMP',chCard) ) lgComBug = .true.
      if( lgMatch('CONT',chCard) ) lgConBug = .true.
      if( lgMatch('CONV',chCard) ) then
*       this is special command, only convergence loops, not full trace
        lgTrConvg = .true.
        lgTrace = .false.
        nznbug = 10000
        nprint = 10000
        itrprt(1) = 10000
      endif
      if( lgMatch('COOL',chCard) ) lgCoolTr = .true.
      if( lgMatch('DIFF',chCard) ) lgTrDiff = .true.
      if( lgMatch(' DR ',chCard) )  lgDrBug = .true.
      if( lgMatch('EDEN',chCard) )  lgNeBug = .true.
      if( lgMatch('GAUN',chCard) ) lgTrGant = .true.
      if( lgMatch('GRAI',chCard) ) lgDustBug = .true.
      if( lgMatch('HEAV',chCard) ) lgHeavyBug = .true.
      if( lgMatch('HEAT',chCard) ) lgHeatBug = .true.
      if( lgMatch('HELI',chCard) ) then
        lgHeBug = .true.
        if( lgMatch('SING',chCard) ) lgHe1Bug = .true.
        if( lgMatch('ATOM',chCard) ) lgHe1Bug = .true.
*       this will match either ionzed or ion
        if( lgMatch(' ION',chCard) ) lgHe2Bug = .true.
        if( lgMatch('TRIP',chCard) ) lgHe3Bug = .true.
      endif
      if( lgMatch('HYDR',chCard) )   then
        lgHBug = .true.
*       option to turn on full printout
        if( lgMatch('FULL',chCard) ) then
          lgHBugFull = .true.
        else
          lgHBugFull = .false.
        endif
      endif
      if( lgMatch('IRON',chCard) )  lgFeBug = .true.
      if( lgMatch('VELN',chCard) )  lgTrLevN = .true.
      if( lgMatch('LINE',chCard) )  lgTrLine = .true.
      if( lgMatch('NEON',chCard) )  lgNeonBug = .true.
      if( lgMatch('MOLE',chCard) ) lgTrMole = .true.
      if( lgMatch('OPAC',chCard) ) lgOpacBug = .true.
*     trace pointers
      if( lgMatch('POIN',chCard) ) lgPointBug = .true.
*     following two are optical, optimize
      if( lgMatch('PTIC',chCard) ) lgOptcBug = .true.
      if( lgMatch('PTIM',chCard) ) lgTrOptm = .true.
      if( lgMatch(' OTS',chCard) ) lgOTSBug = .true.
      if( lgMatch('THRE',chCard) ) lgTrace3Bod = .true.
      if( lgMatch(' TWO',chCard) ) lgBug2nu = .true.
*
      end
