******************************************************************************
      real function plankf( ip )
      implicit none
*evaluate Planck function for any cell at current electron temperature
      integer ip
*
      include "fr1ryd.par"
      include "ncell.par"
      include "rfield.com"
      include "corind.com"
*
*     evaluate Planck function
*     argument is pointer to cell energy in ANU
*     return photon flux for cell IP
      if( ContBoltz(ip).le.0. ) then
        plankf = 1e-35
      else
        plankf = 6.991e-21 * (fr1ryd*anu(ip))**2 / 
     1  (1./ContBoltz(ip) - 1) * fr1ryd * 4.
      endif
*
      end
