******************************************************************************
      subroutine PntForLine( wavelength , chLabel , ipnt )
      implicit none
*generate pointer for forbidden line
      real wavelength
      character chLabel*4
      integer ipnt
      include "rydlam.par"
      include "ncell.par"
      include "LineLabl.com"
      include "linsum.com"
      include "IOqq.com"
*
*     local variables
      integer maxForLin
      parameter (maxForLin=1000)
      integer nForLin , ipForLin(maxForLin)
      integer ipoint
      save nForLin , ipForLin
*
      if( wavelength.lt.0. ) then
        write(qq,'('' PntSetLin called with insane wavelength,='',
     1  1pe10.2)') wavelength
      else if( wavelength.eq.0. ) then
*       zero is special flag to initialize
        nForLin = 0
      else
*
        nForLin = nForLin + 1
        if( ipass .ne. 0) then
*         not first pass, sum lines only
          ipnt =ipForLin(nForLin)
        else
*         check if number of lines in arrays exceeded
          if( nForLin.gt.maxForLin ) then
            write(qq,'(I5,'' lines is too many for '',
     1      ''PntForLine.'')') nForLin
            write(qq,'('' Increase the value of maxForLine everywhere'',
     1      '' in the code.'')')
            stop
          endif
*
          ipForLin(nForLin) = ipoint( rydlam/wavelength )
          ipnt =ipForLin(nForLin)
*         only put in line label if nothing already there
          if(chLineLabel(ipForLin(nForLin)).eq.'    ' ) 
     1     chLineLabel(ipForLin(nForLin)) = chLabel
        endif
      endif
*
      end
