**************************************************************************
      subroutine PrtGamma( n1 , n2 , ip , io , total, threshold)
      implicit none
*special version of gamma function to print strong contributors
      integer n1,n2,ip,io
      real threshold , total
*
      include "en1ryd.par"
      include "ncell.par"
      include "nopsv.par"
      include "opsv.com"
      include "shullc.com"
      include "ots.com"
      include "rfield.com"
      include "SummdCon.com"
      include "LineLabl.com"
*
*     local variables
      integer i , j , k
      real phisig , flxcor
*
*     special special version of GAMFUN to punch step-by-step results
      if(n1 .ge. nflux) return
*
      write(io,'('' PrtGamma from '',1P,E9.2,'' to '',E9.2,''R rates >''
     1,e9.2,'' total='',e9.2)')  anu(n1),anu(n2),threshold ,total
      if( threshold.le.0. .or. total.le.0. ) return
*
      k = n1
      j = min( n2 , nflux )
*
*     do theshold special, do not pick up otscon
      i = k
      phisig = (flux(i)+otslin(i)) * OpacStack(i-k+ip)
      if(phisig.gt.threshold)  then
        flxcor = flux(i) + otslin(i)
        write(io,'(i5,1p,2e9.2,0p,4f5.2,1p,1x,2(a4,1x))')i,
     1  anu(i),phisig/total,
     2  flux(i)/flxcor,otslin(i)/flxcor,otscon(i)/flxcor,
     3  (outcon(i)+outlin(i))/flxcor , chLineLabel(i), chContLabel(i)
      endif
*
      do i=k+1,j
        phisig = SummedCon(i) * OpacStack(i-k+ip)
        if( phisig.gt.threshold) then
          flxcor = flux(i) + otslin(i) + otscon(i)+outlin(i)+outcon(i)
          write(io,'(i5,1p,2e9.2,0p,4f5.2,1p,1x,2(a4,1x))')i,
     1    anu(i),phisig/total,
     2    flux(i)/flxcor,otslin(i)/flxcor,otscon(i)/flxcor,
     3    (outcon(i)+outlin(i))/flxcor , chLineLabel(i), chContLabel(i)
        endif
      end do
*
      end
