******************************************************************************
      subroutine prtmet
      implicit none
*print all line optical depths at end of iteration
      include "nta.par"
      include "ipLnArry.par"
      include "nwindline.par"
      include "TLineARR.com"
      include "WindData.com"
      include "PrtTau.com"
*
*     local variables
      integer i
*
*     default is to not print optical depths, turn on with
*     print optical depths on command
      if( lgPrtTau ) then
*
*       'In' means to zero counter, following elements mean nothing
        call prme('In',  TauLines(1,1) )
*
*       print all lines lines
        do i=1,nTauLines
          call prme(' c',  TauLines(1,i) )
        end do
        do i=1,NWINDLINE*nWindOn
          call prme(' c',  WindLine(1,i) )
        end do
*
*       this means print it
        call prme('  ',  TauLines(1,1) )
      endif
*
      end
