******************************************************************************
      subroutine wgline( chLabel , length , relint , absint , lgOK )
      implicit none
*read line predictions when code used as subroutine with co-added weights 
      logical lgOK
      character*4 chLabel
      integer length
      real relint , absint
*
      include "nlines.par"
      include "wgsum.com"
      include "sum.com"
      include "sum2.com"
      include "sumlab.com"
      include "norm.com"
      include "fourpi.com"
      include "nsumtt.com"
*
*     local variables
      integer ipobs , j
      character*4 chCaps , chFind
*
*     change chLabel to all caps
      call cap4( chLabel , chFind )
      do j=1,nsumtt
*       change chLabel to all caps to be like input chAmLab
        call cap4( chALab(j) , chCaps )
*       check wavelength and chLabel for a match
        if(lin(j).eq.length .and.chCaps.eq.chFind) then
*         match, so set pointer
          ipobs = j
          relint = wgsum(ipobs)/wgsum(NormWL)*sclnrm
          if( wgsum(ipobs).gt.0. ) then
            absint = log10(wgsum(ipobs)) + pirsq
          else
            absint = 0.
          endif
          lgOK = .true.
          return
        endif
      end do
*
      lgOK = .false.
      absint = 0.
      relint = 0.
*
      end
